OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_start")
MEMORY
{
	vectors : org = 0x00000, len = 0x000ff
	libvect : org = 0x00100, len = 0x002ff
	rom     : org = 0x00400, len = 0x1fbff
	/* ram     : org = 0xd8000, len = 0x08000 */
	ram     : org = 0xfef10, len = 0x00fef
	stack   : org = 0xffefc, len = 0x00004
        bkram   : org = 0xd0000, len = 0x0dfff
}
SECTIONS 				
{ 					
.vectors : {
	/* Use something like this to place a specific function's address
	   into the vector table.  */
	LONG(ABSOLUTE(_start))		/* 0x0000 Reset vector */
	LONG(ABSOLUTE(_start))		/* 0x0004  Reserved */
	LONG(ABSOLUTE(_start))		/* 0x0008 */
	LONG(ABSOLUTE(_start))		/* 0x000c */
	LONG(ABSOLUTE(_start))		/* 0x0010 */
	LONG(ABSOLUTE(_start))		/* 0x0014 */
	LONG(ABSOLUTE(_start))		/* 0x0018 */
	LONG(ABSOLUTE(_int_nmi))	/* 0x001c */
	LONG(ABSOLUTE(_int_trap0))	/* 0x0020 */
	LONG(ABSOLUTE(_int_trap1))	/* 0x0024 */

	LONG(ABSOLUTE(_int_trap2))	/* 0x0028 */
	LONG(ABSOLUTE(_int_trap3))	/* 0x002c */
	LONG(ABSOLUTE(_int_irq0))	/* 0x0030 */
	LONG(ABSOLUTE(_int_irq1))	/* 0x0034 */
	LONG(ABSOLUTE(_int_irq2))	/* 0x0038 */
	LONG(ABSOLUTE(_int_irq3))	/* 0x003c */
	LONG(ABSOLUTE(_int_irq4))	/* 0x0040 */
	LONG(ABSOLUTE(_int_irq5))	/* 0x0044 */
	LONG(ABSOLUTE(_start))		/* 0x0048 */
	LONG(ABSOLUTE(_start))		/* 0x004c */

	LONG(ABSOLUTE(_int_wovi))	/* 0x0050 */
	LONG(ABSOLUTE(_int_cmi))	/* 0x0054 */
	LONG(ABSOLUTE(_start))		/* 0x0058 */
	LONG(ABSOLUTE(_start))		/* 0x005c */
	LONG(ABSOLUTE(_int_imia0))	/* 0x0060 */
	LONG(ABSOLUTE(_int_imib0))	/* 0x0064 */
	LONG(ABSOLUTE(_int_ovi0))	/* 0x0068 */
	LONG(ABSOLUTE(_start))		/* 0x006c */
	LONG(ABSOLUTE(_int_imia1))	/* 0x0070 */
	LONG(ABSOLUTE(_int_imib1))	/* 0x0074 */

	LONG(ABSOLUTE(_int_ovi1))	/* 0x0078 */
	LONG(ABSOLUTE(_start))		/* 0x007c */
	LONG(ABSOLUTE(_int_imia2))	/* 0x0080 */
	LONG(ABSOLUTE(_int_imib2))	/* 0x0084 */
	LONG(ABSOLUTE(_int_ovi2))	/* 0x0088 */
	LONG(ABSOLUTE(_start))		/* 0x008c */
	LONG(ABSOLUTE(_int_imia3))	/* 0x0090 */
	LONG(ABSOLUTE(_int_imib3))	/* 0x0094 */
	LONG(ABSOLUTE(_int_ovi3))	/* 0x0098 */
	LONG(ABSOLUTE(_start))		/* 0x009c */

	LONG(ABSOLUTE(_int_imia4))	/* 0x00a0 */
	LONG(ABSOLUTE(_int_imib4))	/* 0x00a4 */
	LONG(ABSOLUTE(_int_ovi4))	/* 0x00a8 */
	LONG(ABSOLUTE(_start))		/* 0x00ac */
	LONG(ABSOLUTE(_int_dend0a))	/* 0x00b0 */
	LONG(ABSOLUTE(_int_dend0b))	/* 0x00b4 */
	LONG(ABSOLUTE(_int_dend1a))	/* 0x00b8 */
	LONG(ABSOLUTE(_int_dend1b))	/* 0x00c0 */
	LONG(ABSOLUTE(_start))		/* 0x00c4 */
	LONG(ABSOLUTE(_start))		/* 0x00c8 */

	LONG(ABSOLUTE(_start))		/* 0x00cc */
	LONG(ABSOLUTE(_start))		/* 0x00d0 */
	LONG(ABSOLUTE(_int_eri0))	/* 0x00d4 */
	LONG(ABSOLUTE(_int_rxi0))	/* 0x00d8 */
	LONG(ABSOLUTE(_int_txi0))	/* 0x00dc */
	LONG(ABSOLUTE(_int_tei0))	/* 0x00e0 */
	LONG(ABSOLUTE(_int_eri1))	/* 0x00e4 */
	LONG(ABSOLUTE(_int_rxi1))	/* 0x00e8 */
	LONG(ABSOLUTE(_int_txi1))	/* 0x00ec */
	LONG(ABSOLUTE(_int_tei1))	/* 0x00f0 */

	LONG(ABSOLUTE(_int_adi))	/* 0x00f4 */

	FILL(0xff)
        }  > vectors
.libvect :{
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))
	LONG(ABSOLUTE(_start))	
	FILL(0xff)
	} > libvect        
        
.bkram : {
	bkram.o(.data)
	bkram.o(.bss)
	bkram.o(COMMON)
	bkram.o(.comm)
	bkram.o(.bkram)
	} > bkram

.text 0x400 : {
	*(.text) 				
	*(.strings)
	*(.rodata) 				
   	 _etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	*(.data)
	*(.tiny)
	 _edata = .;
	} > rom
/* .bss : AT ( LOADADDR(.data) + SIZEOF(.data) ) { */
.bss : {
	 _bss_start = . ;
	*(.bss)
	/* *(COMMON) */
	 _end = . ;  
	}  >ram
.stack : {
	 _stack = . ; 
	*(.stack)
	}  > stack
.stab 0 (NOLOAD) : {
	[ .stab ]
	}
.stabstr 0 (NOLOAD) : {
	[ .stabstr ]
	}
}
