/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    scibuf.c : VAʐMpLN^obt@֐             ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/

#include	"generic.h"
#include	"h8_3048.h"
#include	"sys.h"
#include	"ansi.h"

/*
 * 0x000 - 0x07f  128Byte
 * 0x000 - 0x0ff  256Byte
 * 0x000 - 0x1ff  512Byte
 * 0x000 - 0x3ff 1024Byte
 */

/************************************************************************
 *    錾                                                              *
 ************************************************************************/
/**** ֐錾 ****/
int	fifoInit();
int	txbuf0Input(char);
int	txbuf0Input2(char);
int	txbuf0Inputs(char *, int);
int	txbuf0Output(char *);
int	rxbuf0Input(char);
int	rxbuf0Output(char *);
int	txbuf1Input(char);
int	txbuf1Input2(char);
int	txbuf1Inputs(char *, int);
int	txbuf1Output(char *);
int	rxbuf1Input(char);
int	rxbuf1Output(char *);

/**** ϐ錾 ****/
#define		MAXRBUF		(0x40)
#define		MAXFBUF		(0x80)
#define		MAXRNUM		(MAXRBUF - 1)
#define		MAXBNUM		(MAXFBUF - 1)
extern	char	rxbuf[2][MAXRBUF];	/* Mobt@ */
extern	char	txbuf[2][MAXFBUF];	/* Mobt@ */

extern	int	rxi0p, rxo0p;		/* ch0 Mobt@ʒuϐ */
extern	int	txi0p, txo0p;		/* ch0 Mobt@ʒuϐ */
extern	int	rxi1p, rxo1p;		/* ch1 Mobt@ʒuϐ */
extern	int	txi1p, txo1p;		/* ch1 Mobt@ʒuϐ */

int
checkCharIn(int ch)
{
    if (ch == stdin) {
        return(rxo1p - rxi1p);
    } else {
        return(rxo0p - rxi0p);
    }
}

/************************************************************************
 *    FIFO obt@                                               *
 ************************************************************************/
int
fifoInit()
{
    /**** ʒuϐ̏ ****/
    rxi0p = 0;		rxo0p = 0;
    rxi1p = 0;		rxo1p = 0;
    txi0p = 0;		txo0p = 0;
    txi1p = 0;		txo1p = 0;

    return(1);
}

int
resetSci(int flag)
{
    if (flag & TX0BUF) {
        txi0p = 0;
        txo0p = 0;
    }
    if (flag & TX1BUF) {
        txi1p = 0;
        txo1p = 0;
    }
    if (flag & RX0BUF) {
        rxi0p = 0;
        rxo0p = 0;
    }
    if (flag & RX1BUF) {
        rxi1p = 0;
        rxo1p = 0;
    }
}
    
/************************************************************************
 *    ch0 Mobt@                                              *
 ************************************************************************/
/**** Mobt@ւ1(Â͎̂Ă) ****/
int
txbuf0Input(char c)
{
    /**** input charctor ****/
    txbuf[0][txi0p] = c;
    txi0p = ++txi0p & MAXBNUM;		/* 127->0 */

    /**** set output position ****/
    if (txi0p == txo0p) {		/* over flowÂ̂̂Ă */
	txo0p = ++txo0p & MAXBNUM;
    }

    return(1);
}

/**** Mobt@ւ1(overflow ͋) ****/
int
txbuf0Input2(char c)
{
    /**** buffer overflow check ****/
    if ((txo0p - txi0p) == 1) {
	return(0);
    } else if ((txo0p == 0) && (txi0p == MAXBNUM)) {
	return(0);
    }

    /**** input charactor ****/
    txbuf[0][txi0p] = c;
    txi0p = ++txi0p & MAXBNUM;

    return(1);
}

/**** Mobt@ւn ****/
int
txbuf0Inputs(char *s, int n)
{
    int		i, pn, num;
    
    /**** ͉\vZ ****/
    if ((pn = txi0p - txo0p) >= 0) {
	num = MAXBNUM - pn;
    } else {
	num = txo0p - txi0p - 1;
    }

    /**** ̓ ****/
    for(i=0; i<num; i++) {
	txbuf[0][txi0p] = *s;
	s++;
	txi0p = ++txi0p & MAXBNUM;
	if (i >= n)	break;
    }

    return(i);
}
    

/**** Mobt@1o ****/
int
txbuf0Output(char *c)
{
    char	rtn;
    
    /**** buffer end detect ****/
    if (txo0p == txi0p) {
	return(0);
    }

    /**** charctor output ****/
    *c = txbuf[0][txo0p];
    txo0p = ++txo0p & MAXBNUM;

    return(1);
}

/************************************************************************
 *    ch0 Mobt@                                              *
 ************************************************************************/
/**** Mobt@ւ1(Â͎̂Ă) ****/
int
rxbuf0Input(char c)
{
    /**** input charctor ****/
    rxbuf[0][rxi0p] = c;
    rxi0p = ++rxi0p & MAXRNUM;		/* 127->0 */

    /**** set output position ****/
    if (rxi0p == rxo0p) {		/* over flowÂ̂̂Ă */
	rxo0p = ++rxo0p & MAXRNUM;	/* o̓|WVCNg */
    }

    return(1);
}

/**** Mobt@1o ****/
int
rxbuf0Output(char *c)
{
    char	rtn;
    
    /**** buffer end detect ****/
    if (rxo0p == rxi0p) {
	*c = 0;
	return(0);
    }

    /**** charctor output ****/
    *c = rxbuf[0][rxo0p];
    rxo0p = ++rxo0p & MAXRNUM;

    return(1);
}

/**** Mobt@̕o ****/
int
rxbuf0Outputs(UCHAR *s, int num)
{
    int		i;
    
    /**** buffer end detect ****/
    if (rxo0p == rxi0p) {
	s[0] = '\0';
	return(0);
    }

    /**** charctor output ****/
    for(i=0; i<num; i++) {
        s[i] = rxbuf[0][rxo0p];
        rxo0p = ++rxo0p & MAXRNUM;
        if (rxo0p == rxi0p) {
            i++;
            break;
        }
    }

    return(i);
}

/************************************************************************
 *    ch1 Mobt@                                              *
 ************************************************************************/
/**** Mobt@ւ1(Â͎̂Ă) ****/
int
txbuf1Input(char c)
{
    /**** input charctor ****/
    txbuf[1][txi1p] = c;
    txi1p = ++txi1p & MAXBNUM;		/* 127->0 */

    /**** set output position ****/
    if (txi1p == txo1p) {		/* over flowÂ̂̂Ă */
	txo1p = ++txo1p & MAXBNUM;
    }

    return(1);
}

/**** Mobt@ւ1(overflow ͋) ****/
int
txbuf1Input2(char c)
{
    /**** buffer overflow check ****/
    if ((txo1p - txi1p) == 1) {
	return(0);
    } else if ((txo1p == 0) && (txi1p == MAXBNUM)) {
	return(0);
    }

    /**** input charactor ****/
    txbuf[1][txi1p] = c;
    txi1p = ++txi1p & MAXBNUM;

    return(1);
}

/**** Mobt@ւn ****/
int
txbuf1Inputs(char *s, int n)
{
    int		i, pn, num;
    
    /**** ͉\vZ ****/
    if ((pn = txi1p - txo1p) >= 0) {
	num = MAXBNUM - pn;
    } else {
	num = txo1p - txi1p - 1;
    }

    /**** ̓ ****/
    for(i=0; i<num; i++) {
	if (i >= n)	break;
	txbuf[1][txi1p++] = *s;
	s++;
	txi1p &= MAXBNUM;
    }

    return(i);
}
    

/**** Mobt@1o ****/
int
txbuf1Output(char *c)
{
    char	rtn;
    
    /**** buffer end detect ****/
    if (txo1p == txi1p) {
	return(0);
    }

    /**** charctor output ****/
    *c = txbuf[1][txo1p];
    txo1p = ++txo1p & MAXBNUM;

    return(1);
}

/************************************************************************
 *    ch1 Mobt@                                              *
 ************************************************************************/
/**** Mobt@ւ1(Â͎̂Ă) ****/
int
rxbuf1Input(char c)
{
    /**** input charctor ****/
    rxbuf[1][rxi1p] = c;
    rxi1p = ++rxi1p & MAXRNUM;		/* 127->0 */

    /**** set output position ****/
    if (rxi1p == rxo1p) {		/* over flowÂ̂̂Ă */
	rxo1p = ++rxo1p & MAXRNUM;	/* o̓|WVCNg */
    }

    return(1);
}

/**** Mobt@1o ****/
int
rxbuf1Output(char *c)
{
    char	rtn;
    
    /**** buffer end detect ****/
    if (rxo1p == rxi1p) {
	*c = 0;
	return(0);
    }

    /**** charctor output ****/
    *c = rxbuf[1][rxo1p];
    rxo1p = ++rxo1p & MAXRNUM;

    return(1);
}

/**** Mobt@̕o ****/
int
rxbuf1Outputs(char *s, int num)
{
    int		i;
    
    /**** buffer end detect ****/
    if (rxo1p == rxi1p) {
	s[0] = '\0';
	return(0);
    }

    /**** charctor output ****/
    for(i=0; i<num; i++) {
        s[i] = rxbuf[1][rxo1p];
        rxo1p = ++rxo1p & MAXRNUM;
        if (rxo1p == rxi1p) {
            i++;
            break;
        }
        
    }
    s[i] = '\0';
    return(i);
}

/* end of file */
