/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    comenv.c : COM|[gݒ                                    ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"include/sys.h"
#include	"h8_3048.h"

/*
[SCI Ch0]   57600bps
  Len:8 Stp:1 Pty:Od
[SCI Ch1]   57600bps
  Len:8 Stp:1 Pty:D
*/
extern void	setSysParam(int, int, int);
extern void	sysParamRec();

int	execComEnv();
int	comEnvLoop();
void	dispCursor(int);
void	incDecModeData(int, int);
void	incDecBps(int, int);
void	incDecDlen(int, int);
void	incDecStop(int, int);
void	incDecPrty(int, int);
void	dispBaud();
void	dispDataLen();
void	dispStopLen();
void	dispParity();
void	saveComEnv();

char	*pstr[3] = { "Pty:Ds", "Pty:Ev", "Pty:Od" };
extern	UCHAR	cdlen[2], cstop[2], cprty[2];
extern	UINT	cbps[2];

void
dispCursor(int mode)
{
    switch(mode) {
    case 0:    lcdMoveto(0, 17);    break;
    case 1:    lcdMoveto(1,  6);    break;
    case 2:    lcdMoveto(1, 12);    break;
    case 3:    lcdMoveto(1, 19);    break;
    case 4:    lcdMoveto(2, 17);    break;
    case 5:    lcdMoveto(3,  6);    break;
    case 6:    lcdMoveto(3, 12);    break;
    case 7:    lcdMoveto(3, 19);    break;
    }
}

void
incDecModeData(int mode, int sub) 
{
    switch(mode) {
    case 0:    incDecBps(0, sub);     break;
    case 1:    incDecDlen(0, sub);    break;
    case 2:    incDecStop(0, sub);    break;
    case 3:    incDecPrty(0, sub);    break;
    case 4:    incDecBps(1, sub);     break;
    case 5:    incDecDlen(1, sub);    break;
    case 6:    incDecStop(1, sub);    break;
    case 7:    incDecPrty(1, sub);    break;
    }
}

void
incDecBps(int ch, int sub)
{
    UCHAR	str[8];
    int		l, place;

    if (ch == 0)    l = 0;
    else            l = 2;
    lcdMoveto(l, 12);    lcdOut("   ");
    switch(cbps[ch]) {
    case 960:
        if(sub == 1) { cbps[ch]=1920; place = 13; }
        else         { cbps[ch]=960;  place = 14; }
        break;
    case 1920:
        if(sub == 1) { cbps[ch]=3125; place = 13; }
        else         { cbps[ch]=960;  place = 14; }
        break;
    case 3125:
        if(sub == 1) { cbps[ch]=3840; place = 13; }
        else         { cbps[ch]=1920; place = 13; }
        break;
    case 3840:
        if(sub == 1) { cbps[ch]=5760; place = 13; }
        else         { cbps[ch]=3125; place = 13; }
        break;
    case 5760:
        if(sub == 1) { cbps[ch]=6250; place = 13; }
        else         { cbps[ch]=3840; place = 13; }
        break;
    case 6250:
        if(sub == 1) { cbps[ch]=10000; place = 12; }
        else         { cbps[ch]=5760;  place = 13; }
        break;
    case 10000:
        if(sub == 1) { cbps[ch]=12500; place = 12; }
        else         { cbps[ch]=6250;  place = 13; }
        break;
    case 12500:
        if(sub == 1) { cbps[ch]=25000; place = 12; }
        else         { cbps[ch]=10000; place = 12; }
        break;
    case 25000:
        if(sub == 1) { cbps[ch]=25000; place = 12; }
        else         { cbps[ch]=12500; place = 12; }
        break;
    }
    lcdMoveto(l, place);
    itostr(cbps[ch], str, 10);  lcdOut(str); lcdOut("0");
    lcdMoveto(l, 17);
}

void
incDecDlen(int ch, int sub)
{
    int		l;
    
    if (ch == 0)   l = 1;
    else           l = 3;
    lcdMoveto(l, 2);
    if (cdlen[ch] == 7) { cdlen[ch] = 8;      lcdOut("Len:8"); }
    else                { cdlen[ch] = 7;      lcdOut("Len:7"); }
    lcdMoveto(l, 6);
}

void
incDecStop(int ch, int sub)
{
    int		l;

    if (ch == 0)   l = 1;
    else           l = 3;
    lcdMoveto(l, 8);
    if (cstop[ch] == 1) { cstop[ch] = 2;      lcdOut("Stp:2"); }
    else                { cstop[ch] = 1;      lcdOut("Stp:1"); }
    lcdMoveto(l, 12);
}


void
incDecPrty(int ch, int sub)
{
    int		l;

    if (ch == 0)   l = 1;
    else           l = 3;
    lcdMoveto(l, 14);
    cprty[ch] = (UCHAR)((char)cprty[ch] + (char)sub);
    if ((cprty[ch] == 0) && (sub < 0))    cprty[ch] = 0;
    if (cprty[ch] > 2)                    cprty[ch] = 2;
    lcdOut(pstr[cprty[ch]]);
    lcdMoveto(l, 19);
}

void
dispBaud()
{
    UCHAR	str[8];

    switch(cbps[0]){
    case 960:     lcdMoveto(0, 14);    break;
    case 1920:    case 3125:    case 3840:    case 5760:
    case 6250:    lcdMoveto(0, 13);    break;
    case 10000:   case 12500:
    case 25000:   lcdMoveto(0, 12);    break;
    }
    itostr(cbps[0], str, 10);  lcdOut(str); lcdOut("0");
    switch(cbps[1]){
    case 960:     lcdMoveto(2, 14);    break;
    case 1920:    case 3125:    case 3840:    case 5760:
    case 6250:    lcdMoveto(2, 13);    break;
    case 10000:   case 12500:
    case 25000:   lcdMoveto(2, 12);    break;
    }
    itostr(cbps[1], str, 10);  lcdOut(str); lcdOut("0");
}

void
dispDataLen()
{
    lcdMoveto(1, 2);
    if (cdlen[0] == 7) lcdOut("Len:7");
    else               lcdOut("Len:8");
    lcdMoveto(3, 2);
    if (cdlen[1] == 7) lcdOut("Len:7");
    else               lcdOut("Len:8");
}

void
dispStopLen()
{
    lcdMoveto(1, 8);
    if (cstop[0] == 1) lcdOut("Stp:1");
    else               lcdOut("Stp:2");
    lcdMoveto(3, 8);
    if (cstop[1] == 1) lcdOut("Stp:1");
    else               lcdOut("Stp:2");
}

void
dispParity() 
{
    lcdMoveto(1, 14);
    lcdOut(pstr[cprty[0]]);
    lcdMoveto(3, 14);
    lcdOut(pstr[cprty[1]]);
}

void
setComEnv(int ch, int type, UINT d)
{
    if ((ch != 0) && (ch != 1))    return;
    
    switch(type) {
    case SCI_DLEN:
        if ((d == 7) || (d == 8))  cdlen[ch] = (UCHAR)d;
        break;
    case SCI_STOP:
        if ((d == 1) || (d == 2))  cdlen[ch] = (UCHAR)d;
        break;
    case SCI_PRTY:
        if ((d >= 0) && (d <= 2))  cprty[ch] = (UCHAR)d;
        break;
    case SCI_BPS:
        cbps[ch] = d;
        break;
    }
}

void
saveComEnv()
{
    int		i;

    lcdCommand(CLEAR);
    lcdCommand(BRINK_OFF);
    lcdCommand(CUR_OFF);
    lcdMoveto(1, 2);
    lcdOut("Saving data... ");
    /* cdlen[2], cstop[2], cprty[2], cbps[2] ۑ */
    for(i=0; i<2; i++) {
        setSysParam(SCI_DLEN, (int)cdlen[i], i);
        setSysParam(SCI_STOP, (int)cstop[i], i);
        setSysParam(SCI_PRTY, (int)cprty[i], i);
        setSysParam(SCI_BPS,  (int)cbps[i],  i);
    }
    sysParamRec();
    lcdOut("OK");
    lcdMoveto(2, 2);
    lcdOut("Please Restart");
}

/* end of file */

