/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    msg.c : LCDbZ[Wo                                   ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"include/sys.h"

#define		pantopos(x)	((x & 0xf8)? x-8 : 0)

extern	void	lcdOut(char *);
extern  void	lcdMoveto(int, int);
extern	void	lcdMoveOut(int, int, char *);
extern	void	lcdMoveOutn(int, int, char *, int);

void	initmsg();
int	startmsg();
void	graphOutMain(MnAttr *, int);
void	graphOutAuxRtn(MnAttr *, int);
void	graphChData(MnAttr *, UCHAR **, UCHAR **, UCHAR, UCHAR, int, int);
void	graphOutPan(ChAttr *, int, int, int, int);
void	dispChData(UCHAR, UCHAR *, UCHAR, UCHAR, UCHAR *, int, int);
void	graphOutCh(ChAttr *, ChAttr *, int, int);
void	graphPanVol(ChAttr *, ChAttr *, int, int);
void	numCmpOut(UCHAR, UCHAR *, UCHAR, UCHAR, UCHAR *, int, int, int);
void	numOutCh(ChAttr *, ChAttr *, int, int);
void	numOutAuxCh(ChAttr *, ChAttr *, int, int);
void	dispVgraph(UCHAR, int, int);
void	clear_vgraph(int, int);
void	disp_hgraph(int, int, int, int);
void	disp_start(MnAttr *, MnAttr *, ChAttr *, ChAttr *, int, int);
int	dispMain(MnAttr *, MnAttr *, ChAttr *, ChAttr *, int, int);
int	chOutNumTitle();
int	chOutNumAuxTitle();
int	dispCH(MnAttr *, MnAttr *, ChAttr *, ChAttr *, int, int);
int	checkYesNo();

extern	ChAttr	chd[16];
extern	MnAttr	mnd;

#include "defstr.h"

/* static  int	maxlow=4; */		/* s */
/* static  int	maxcol=20; */		/*  */
extern	char	*scale[10][4];		/* XP[ */
extern	int	col, lin;		/* JgsE */
extern	int	top, sec;		/* \[h(top/second) */
extern	int	mode;
extern	int     mnum, pgrp, pch;
extern	int	cnum;
extern	int	dmode;
extern	UCHAR   ppan, pdpan;
extern	UCHAR	asend[4], arr[4], arl[4]; /* \p Aux send/return*/
extern	UCHAR   chi, cmid, clow, cpan;    /* \p Tone, pan */
extern	UCHAR	cv, mvl, mvr;             /* \p volume */
extern	UCHAR	dlock, dsta, panel;

/************************************************************************
 *    LCD o̓f[^̏                                            *
 ************************************************************************/
void
initmsg()
{
    int		i, j;

    mode = 0;
    /* maxcol = 20; */
    /* maxlow = 4; */
    top = 0;
    sec = 0;
    mnum = -1;
    pgrp = -1;
    dmode = -1;
    ppan = 0;
    cnum = -1;
    dsta = 1;

    /**** XP[p̃|C^ATC ****/
    for(i=0; i<4; i++) {
        scale[0][i] = scsrc[0];
        scale[9][i] = scsrc[5];
    }

    for(j=1; j<9; j++) {
        scale[j][0] = scsrc[1];
        scale[j][1] = scsrc[2];
        scale[j][2] = scsrc[3];
        scale[j][3] = scsrc[4];
    }
}

/************************************************************************
 *    plbN\                                                  *
 ************************************************************************/
int
dispLockM()
{
    if (dlock == 0) {
        lcdMoveto(0, 14);
        lcdOut("Lock");
    }
    dlock |= 0x01;
    lcdMoveto(0, 18);
    lcdOut("M");
}

int
dispUnlockM()
{
    dlock &= 0xfe;
    if (dlock == 0) {
        lcdMoveto(0, 14);
        lcdOut("      ");
    } else {
        lcdMoveto(0, 18);
        lcdOut(" ");
    }
}

int
dispLockC()
{
    if (dlock == 0) {
        lcdMoveto(0, 14);
        lcdOut("Lock");
    }
    dlock |= 0x02;
    lcdMoveto(0, 19);
    lcdOut("C");
}

int
dispUnlockC()
{
    dlock &= 0xfd;
    if (dlock == 0) {
        lcdMoveto(0, 14);
        lcdOut("      ");
    } else {
        lcdMoveto(0, 19);
        lcdOut(" ");
    }
}
    
/************************************************************************
 *    bZ[Wo                                                *
 ************************************************************************/
/*
 * 0        1         2
 * 12345678901234567890
 * ****  KMix-016  ****
 * 16Channel
 *   Digital controled
 *     analog mixer.
 */
int
startmsg()
{
    int	  i;
    char  buf[21];
    char  *inititle = "****  KMIX-016  ****";
    char  *inimsg   ="16 channel\n  Digtal controled\n    analog mixer";

    if (mode >= 20) {
	mode++;
	if (mode >= (20 + 10))	return(0);
    } else {
	if (mode == 0) {
	    lcdMoveOut(1, 0, inimsg);
	}
	mode++;
	lcdMoveto(0, 20-mode);
	for(i=0; i<mode; i++) {
	    buf[i] = inititle[i];
	}
	buf[i] = '\0';
	lcdOut(buf);
    }
    return(1);
}

/************************************************************************
 *    C{[EwbhtH{[̕\                    *
 ************************************************************************/
void
graphOutMain(MnAttr *md, int flag)
{
    if ((md->mnflg & 0x40) || flag)
        { dispVgraph(md->phonel,  1, 14);    md->mnflg &= 0xbf; }
    if ((md->mnflg & 0x10) || flag)
        { dispVgraph(md->mainl,   1, 15);    md->mnflg &= 0xef; }
    if ((md->mnflg & 0x80) || flag)
        { dispVgraph(md->phoner,  1, 17);    md->mnflg &= 0x7f; }
    if ((md->mnflg & 0x20) || flag)
        { dispVgraph(md->mainr,   1, 18);    md->mnflg &= 0xdf; }
}

/************************************************************************
 *    AUX Return {[̕\                                       *
 ************************************************************************/
void
graphOutAuxRtn(MnAttr *md, int flag)
{
    if ((md->alflg & 0x10) || flag)
        { dispVgraph(md->auxl[0], 1,  2);    md->alflg &= 0xef; }
    if ((md->arflg & 0x10) || flag)
        { dispVgraph(md->auxr[0], 1,  3);    md->arflg &= 0xef; }
    if ((md->alflg & 0x20) || flag)
        { dispVgraph(md->auxl[1], 1,  5);    md->alflg &= 0xdf; }
    if ((md->arflg & 0x20) || flag)
        { dispVgraph(md->auxr[1], 1,  6);    md->arflg &= 0xdf; }
    if ((md->alflg & 0x40) || flag)
        { dispVgraph(md->auxl[2], 1,  8);    md->alflg &= 0xbf; }
    if ((md->arflg & 0x40) || flag)
        { dispVgraph(md->auxr[2], 1,  9);    md->arflg &= 0xbf; }
    if ((md->alflg & 0x80) || flag)
        { dispVgraph(md->auxl[3], 1, 11);    md->alflg &= 0x7f; }
    if ((md->arflg & 0x80) || flag)
        { dispVgraph(md->auxr[3], 1, 12);    md->arflg &= 0x7f; }
    graphOutMain(md, flag);
}

/************************************************************************
 *    CH Group̃f[^\(panȊO)                                     *
 ************************************************************************/
void
graphChData(MnAttr *md, UCHAR **dat, UCHAR **flg,
            UCHAR mask, UCHAR dd, int ch, int upd)
{
    int		i, p, sta;

    /**** ݒl̍XV ****/
    sta = ch & 0xfc;
    for(i=0; i<4; i++) {
        if ((*flg[sta+i] & mask) || upd) {
            p = 3 * i + 3;
            dispVgraph(*dat[sta+i], 1, p);
            *flg[sta+i] = *flg[sta+i] & ~mask;
        }
    }

    /**** ^[Qbg`lADlXV ****/
    if (pch != ch) {			/* Och̃Ot */
        p = (pch & 0x03) * 3 + 2;
        dispVgraph(0, 1, p);
    }
    p = (ch & 0x03) * 3 + 2;
    dispVgraph(dd, 1, p);
    graphOutMain(md, upd);
}

/************************************************************************
 *    panpod f[^\                                                 *
 ************************************************************************/
void
graphOutPan(ChAttr *dcd, int ch, int upd, int offset, int chflg)
{
    int		pos;

    if (chflg) {
        if ((pch != ch) || upd)    lcdMoveOut(1, 0, chstr[ch+1]);
    }
    
    if ((*chtflg[ch] & 0x80) || upd) {
        pos = pantopos(ppan) >> 3;
        lcdMoveOut(2, pos+offset, "-");
        pos = pantopos(*chpan[ch]) >> 3;
        lcdMoveOut(2, pos+offset, "o");
        ppan = *chpan[ch];
        *chtflg[ch] = *chtflg[ch] & 0xf7;
    }

    pos = pantopos(dcd->pan) >> 3;
    if ((pos != pdpan) || upd) {
        lcdMoveOut(1, pdpan+offset, "-");
        lcdMoveOut(1, pos+offset, "o");
        pdpan = pos;
    }
}

/************************************************************************
 *    ch@̃f[^\                                                *
 ************************************************************************/
void
dispChData(UCHAR sd, UCHAR *sflg, UCHAR mask,
           UCHAR dd, UCHAR *dbck, int place, int upd)
{
    UCHAR    data, cmpd;
    
    if ((*sflg & mask) || upd) {
        dispVgraph(sd, 1, place+1);
        *sflg &= ~mask;
    }
    data = dd >> 3;
    cmpd = *dbck >> 3;
    if ((data != cmpd) || upd) {
        dispVgraph(dd, 1, place);
    }
    *dbck = dd;
}

void
graphOutCh(ChAttr *cd, ChAttr *dcd, int ch, int upd)
{
    UCHAR	data;

    dispChData(cd[ch].hi,  &(cd[ch].tflg), 0x40, dcd->hi,  &chi,  0, upd);
    dispChData(cd[ch].mid, &(cd[ch].tflg), 0x20, dcd->mid, &cmid, 3, upd);
    dispChData(cd[ch].low, &(cd[ch].tflg), 0x10, dcd->low, &clow, 6, upd);
    dispChData(cd[ch].snd[0], &(cd[ch].sflg), 0x10,
               dcd->snd[0], &(asend[0]), 9, upd);
    dispChData(cd[ch].snd[1], &(cd[ch].sflg), 0x20,
               dcd->snd[1], &(asend[1]), 12, upd);
    dispChData(cd[ch].snd[2], &(cd[ch].sflg), 0x40,
               dcd->snd[2], &(asend[2]), 15, upd);
    dispChData(cd[ch].snd[3], &(cd[ch].sflg), 0x80,
               dcd->snd[3], &(asend[3]), 18, upd);
}

void
graphPanVol(ChAttr *cd, ChAttr *dcd, int ch, int upd)
{
    UCHAR	data, cmpd;

    /**** PAN o͂̕\ ****/
    if (upd) {
        lcdMoveto(1,0);  lcdOut("|---------------|");
        lcdMoveto(2,0);  lcdOut("|---------------|");
    }
    graphOutPan(dcd, ch, upd, 1, 0);

    /**** Volume o͂̕\ ****/
    data = (dcd->vol) >> 3;
    cmpd = cv >> 3;
    if ((data != cmpd) || upd) {
        dispVgraph(dcd->vol, 1, 18);
    }
    cv = dcd->vol;
    if (CHKDFLAG(cd[ch].vflg) || upd) {
        dispVgraph(cd[ch].vol, 1, 19);
        DFLAGOFF(cd[ch].vflg);
    }
}

void
numCmpOut(UCHAR cdat, UCHAR *f, UCHAR mask,
          UCHAR ddat, UCHAR *b, int l, int pos, int up)
{
    if ((ddat != *b) || up) {
        lcdMoveOut(l, pos, nstr[ddat]);
        lcdOut("/");
        *b = ddat;
    } else {
        lcdMoveOut(l, pos+3, "/");
    }

    if ((*f & mask) || up) {
        lcdMoveOut(l, pos+4, nstr[cdat]);
        *f &= ~mask;
    }
}

void
numOutCh(ChAttr *cd, ChAttr *dcd, int ch, int upd)
{
    UCHAR	data;

    numCmpOut(cd[ch].vol, &(cd[ch].vflg), 0x10, dcd->vol, &cv,   1,  2, upd);
    numCmpOut(cd[ch].pan, &(cd[ch].tflg), 0x80, dcd->pan, &cpan, 1, 12, upd);
    numCmpOut(cd[ch].hi,  &(cd[ch].tflg), 0x40, dcd->hi,  &chi,  2,  2, upd);
    numCmpOut(cd[ch].mid, &(cd[ch].tflg), 0x20, dcd->mid, &cmid, 2, 12, upd);
    numCmpOut(cd[ch].low, &(cd[ch].tflg), 0x10, dcd->low, &clow, 3,  2, upd);
}

void
numOutAuxCh(ChAttr *cd, ChAttr *dcd, int ch, int up)
{
    numCmpOut(cd[ch].snd[0], &(cd[ch].sflg), 0x10, 
              dcd->snd[0], &(asend[0]), 2,2,up);
    numCmpOut(cd[ch].snd[1], &(cd[ch].sflg), 0x20, 
              dcd->snd[1], &(asend[1]), 2,12,up);
    numCmpOut(cd[ch].snd[2], &(cd[ch].sflg), 0x40, 
              dcd->snd[2], &(asend[2]), 3,2,up);
    numCmpOut(cd[ch].snd[3], &(cd[ch].sflg), 0x80, 
              dcd->snd[3], &(asend[3]), 2,12,up);
}

/************************************************************************
 *    c`OtLCDo                                               *
 ************************************************************************/
void
dispVgraph(UCHAR data, int line, int col)
{
    UCHAR	up[2], low[2];
    int		unit, place;

    up[1] = low[1] = '\0';
    up[0] = low[0] = (data & 0x3f) >> 3;
    if (data & 0x40)	low[0] = 0x0f;
    else		up[0]  = ' ';
    if (data == 0)      low[0] = ' ';
    lcdMoveOutn(line, col, up, 1);
    lcdMoveOutn(line+1, col, low, 1);
}

/**** OtNA ****/
void
clear_vgraph(int col, int offset)
{
    UCHAR	*space;
    int		place;

    space = " ";
    place = 2 + col * 3 + offset;
    lcdMoveOut(2, place, space);
    lcdMoveOut(1, place, space);
}

/************************************************************************
 *    `Ot̕\                                                  *
 ************************************************************************/
void
disp_hgraph(int value, int full, int line, int col)
{
    char	buf[3];
    int		d, i, max;
    
    lcdMoveto(line, col);
    buf[0] = 0xff;
    buf[1] = '\0';
    d = value;
    max = full / 5;
    for(i=0; i<full; i= i+5) {
	if ((d - 5) < 0) break;
	d = d - 5;
	lcdOut(buf);
    }
    lcdCharOut(d);
    i++;
    for(; i<full; i= i+5) {
	lcdCharOut(' ');
    }
}

/************************************************************************
 *    ʏ\X^[g                                                  *
 ************************************************************************/
void
disp_start(MnAttr *md, MnAttr *dmd, ChAttr *cd, ChAttr *dcd, int n, int ch)
{
    initVCgRam();			/* OttHg */
    lcdCommand(CUR_OFF);		/* J[\ */
    lcdCommand(BRINK_OFF);		/* J[\_łȂ */
    lcdCommand(CLEAR);			/* \NA */

    dispMain(md, dmd, cd, dcd, n, ch);

}

/************************************************************************
 *    Main f[^̕\                                                 *
 ************************************************************************/
int
dispMain(MnAttr *md, MnAttr *dmd, ChAttr *cd, ChAttr *dcd, int num, int ch)
{
    int		grp, init=0;
    UCHAR	d[6][2];

    /**** ^Cg\ ****/
    if (mnum != num) {
        lcdCommand(CLEAR);		/* \NA */
        lcdMoveto(0, 0);		/* J[\z[|WV */
        lcdOut(mtitle[num]);
        mnum = num;
        init = 1;
        pgrp = -1;
        if (num == 9) {
            lcdMoveto(1,2);  lcdOut("|---------------|");
            lcdMoveto(2,2);  lcdOut("|---------------|");
        }
        if (panel & MNLOCK)	dispLockM();
        if (panel & CHLOCK)	dispLockC();
    }

    /**** XP[\ ****/
    grp = ch >> 2;
    if (pgrp != grp) {
        lcdMoveto(3, 0);
        lcdOut(scale[num][grp]);
        pgrp = grp;
        init = 1;
    }

    switch(num) {
    case 0:
        graphOutAuxRtn(md, init);
        break;
    case 1:
        graphChData(md, chvol, chvflg, 0x10, dcd->vol, ch, init);
        break;
    case 2:
        graphChData(md, chhi,  chtflg, 0x40, dcd->hi,  ch, init);
        break;
    case 3:
        graphChData(md, chmid, chtflg, 0x20, dcd->mid, ch, init);
        break;
    case 4:
        graphChData(md, chlow, chtflg, 0x10, dcd->low, ch, init);
        break;
    case 5:
        graphChData(md, chsnd[0], chsflg[0], 0x10, dcd->snd[0], ch, init);
        break;
    case 6:
        graphChData(md, chsnd[1], chsflg[1], 0x20, dcd->snd[1], ch, init);
        break;
    case 7:
        graphChData(md, chsnd[2], chsflg[2], 0x40, dcd->snd[2], ch, init);
        break;
    case 8:
        graphChData(md, chsnd[3], chsflg[3], 0x80, dcd->snd[3], ch, init);
        break;
    case 9:
        graphOutPan(dcd, ch, init, 3, 1);
        break;
    }

    pch = ch;
    cnum = -1;
}

int
chOutNumTitle()
{
    lcdMoveOut(1, 0,  "V:");
    lcdMoveOut(1, 10, "P:");
    lcdMoveOut(2, 0,  "H:");
    lcdMoveOut(2, 10, "M:");
    lcdMoveOut(3, 0,  "L:");
}

int
chOutNumAuxTitle()
{
    lcdMoveOut(1, 0,  "Aux send");
    lcdMoveOut(2, 0,  "1:");
    lcdMoveOut(2, 10, "2:");
    lcdMoveOut(3, 0,  "3:");
    lcdMoveOut(3, 10, "4:");
}

/************************************************************************
 *    CH ̃f[^\                                                 *
 ************************************************************************/
int
dispCH(MnAttr *md, MnAttr *dmd, ChAttr *cd, ChAttr *dcd, int num, int ch)
{
    int		init = 0;

    /**** ^Cg\ ****/
    if (cnum != num) {
        lcdCommand(CLEAR);		/* \NA */
        lcdMoveto(0, 0);
        lcdOut("Channel[  ]");
        init = 1;
    }
    if ((cnum != num) || (pch != ch)) {
        lcdMoveto(0, 8);
        lcdOut(chstr[ch+1]);
        init = 1;
    }
    
    /**** XP[\ ****/
    if (cnum != num) {
        lcdMoveto(3, 0);
        switch(num) {
        case  0:    lcdOut(scsrc[6]);    break;
        case  1:    lcdOut(scsrc[7]);    break;
        case  2:    chOutNumTitle();     break;
        case  3:    chOutNumAuxTitle();  break;
        }
    }

    switch(num) {
    case 0:    graphOutCh(cd, dcd, ch, init);    break;
    case 1:    graphPanVol(cd, dcd, ch, init);   break;
    case 2:    numOutCh(cd, dcd, ch, init);      break;
    case 3:    numOutAuxCh(cd, dcd, ch, init);   break;
        
    }
    cnum = num;
    pch = ch;
    mnum = -1;
}

/************************************************************************
 *
 ************************************************************************/
void
resetDisp()
{
    panel = 0;
    dlock = 0;
    mnum = -1;
    cnum = -1;
    pch  = -1;
}

/************************************************************************
 *    LCD̃j[\                                                 *
 ************************************************************************/
void
startMenu()
{
    dsta = 1;
}

void
dispMenu()
{
    if (dsta) {
        lcdCommand(CLEAR);
        lcdMoveto(0, 0);
        lcdOut("Edit Menu");

        lcdMoveto(1, 1);    lcdOut("1:Save     2:MIDI");
        lcdMoveto(2, 1);    lcdOut("3:System   4:Fade");
        lcdMoveto(3, 1);    lcdOut("5:COM      6:Info");
        lcdMoveto(1, 1);
        lcdCommand(CUR_ON);
        lcdCommand(BRINK_ON);
        dsta = 0;
    }
    mnum = -1;
    cnum = -1;
    pch  = -1;
}

void
exitMenu()
{
    dsta = 1;
    lcdCommand(BRINK_OFF);
    lcdCommand(CUR_OFF);
}

int
incMenu(int mn, int n)
{
    int		line, col, max;

    if ((n == 2) && ((mn & 0x01) == 0))	max = 4;
    else				max = 5;
    
    mn = mn + n;
    if (mn > 5) mn = max;
    line = 1 + (mn >> 1);
    col  = 11 * (mn & 0x01) + 1;
    lcdMoveto(line, col);

    return(mn);
}

int
decMenu(int mn, int n)
{
    int		line, col, min;

    if ((n == 2) && ((mn & 0x01) == 1))	min = 1;
    else				min = 0;

    mn = mn - n;
    if (mn < 0) mn = 0;
    line = 1 + (mn >> 1);
    col  = 11 * (mn & 0x01) + 1;
    lcdMoveto(line, col);

    return(mn);
}

/************************************************************************
 *    checkYesNo() :
 ************************************************************************/
int
checkYesNo()
{
    int		rtn, ch, stat;
    UCHAR	sndsw;

    lcdMoveto(3, 5);
    lcdOut("Yes / No ?");
    lcdMoveto(3, 5);
    rtn = 1;

    ch = getCurCH();
    sndsw = getCurSendSW();
    while(1) {
	if (checkTimeFlag(T0004MSEC)) {
            /*pccom(4);*/
	}
	if (checkTimeFlag(T0016MSEC)) {
            stat  = (UCHAR)getSwStat(TACTSW, DOWN_STAT);
            if (stat & 0x01) {
                lcdMoveto(3, 11);
                rtn = 0;
            } else if (stat & 0x04) {
                lcdMoveto(3, 5);
                rtn = 1;
            } else if (stat & 0x10) {
                lcdMoveto(3, 5);
                lcdOut("          ");
                break;
            } else if (stat & 0x40) {
                lcdMoveto(3, 5);
                lcdOut("          ");
                rtn = 0;
                break;
            }
        }
    }
    return(rtn);
}
    
/* end of file */
