/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    pccom.c : PC ʐM                                       ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"include/generic.h"
#include	"include/config.h"
#include	"include/h8_3048.h"
#include	"include/sys.h"

/**** PC->Mixer R}h ****/
/* ch f[^MR}h */
#define	CMD_CHDREQ	(0x10)
#define CMD_CHDRCV	(0x11)
#define CMD_CHRCV	(0x12)

/* main f[^MR}h */
#define	CMD_MNDREQ	(0x20)
#define	CMD_MNDRCV	(0x21)
#define CMD_MNRCV	(0x22)

/* VXeݒ֘AMR}h */
#define	CMD_NONE	(0x00)
#define CMD_PGM		(0x30)
#define CMD_PGMNAME	(0x31)
#define CMD_PGMDATE	(0x32)
#define CMD_LOCK	(0x33)
#define CMD_SYSREQ	(0x40)
#define CMD_SYSSET	(0x41)
#define CMD_PINGIN	(0xaa)
#define CMD_PINGOUT	(0xa5)

/**** Mixer->PCR}h ****/
#define CMD_ACK		(0x55)
#define CMD_CHDSEND	(0x80)
#define CMD_PGMNUM	(0x82)
#define CMD_MNDSEND	(0x81)
#define CMD_NAMESEND	(0x83)
#define CMD_PGMEND	(0x88)
#define CMD_LOADOK	(0x89)
#define CMD_SYSENV	(0x8a)

extern	int	pgmInit(int);
extern	int	pgmIncDec(int);
extern	int	savePgmData(int, ChAttr *, MnAttr *, char *);
extern	int	loadPgm(int, ChAttr *, MnAttr *);
extern	int	falshProgram(UCHAR *, UCHAR *, ULONG);
extern	int	execSavePgm();
extern	void	waitSecLoop(int);
extern	void	pgmnoWarning();
extern	int	getpgmStrLoop();
extern	void	nstripPstr(char *, int);
extern	void	stripPstr(char *);
extern	int	pstrlen(char *);
extern	int	delStr(char *, int);
extern	void	refleshNameSpace(char *, int);
extern	int	getPushStat(UCHAR);

extern	int	miscInit();
extern	int	execDispInfo();
extern	int	execSysEnv();
extern	void	dispSysEnv(int);
extern	int	editSysEnv(int, int);
extern	void	dispBeepOnOff();
extern	int	editBeepOnOff(int);
extern	void	dispBeepFreq();
extern	int	editBeepFreq(int);
extern	void	dispBeepMsec();
extern	int	editBeepMsec(int);
extern	void	dispContrast();
extern	int	editContrast(int, UCHAR);
extern	void	saveSysEnv();

extern	int	execComEnv();
extern	int	comEnvLoop();
extern	void	dispCursor(int);
extern	void	incDecModeData(int, int);
extern	void	incDecBps(int, int);
extern	void	incDecDlen(int, int);
extern	void	incDecStop(int, int);
extern	void	incDecPrty(int, int);
extern	void	dispBaud();
extern	void	dispDataLen();
extern	void	dispStopLen();
extern	void	dispParity();
extern	void	saveComEnv();

extern	void	BeepEnable();
extern	void	BeepDisable();
extern	UINT	getBeepLen();
extern	void	Beep(int);
extern	void	setBeepLength(UINT);
extern	void	sysParamInit();
extern	void	sysParamRec();

extern	int	sciSetBaud(int, int);
extern	UINT	sciGetBaud(int);
extern	int	sciSetMode(int, int, int, int);
extern	int	getSciDataLen(int);
extern	int	getSciParity(int);
extern	int	getSciStopBit(int);
extern	UCHAR	getStartMode();
extern	void	setStartMode(UCHAR);

extern	void	pcmnseton();
extern	void	pcmnsetoff();
extern	void	pcchseton();
extern	void	pcchsetoff();

void	pcomInit(void);
int	cmd_ping(UCHAR *);
int	cmd_chdsend(UCHAR *);
int	cmd_chdrcv(UCHAR *);
int	cmd_chrcv(UCHAR *);
int	cmd_mndsend(UCHAR *);
int	cmd_mndrcv(UCHAR *);
int	cmd_mnrcv(UCHAR *);
int	cmd_pgm(UCHAR *);
int	cmd_pgmname(UCHAR *);
int	cmd_pgmdate(UCHAR *);
int	cmd_lock(UCHAR *);
void	pgmInfoToPC(int);
void	pgmNGToPC(void);
int	cmd_sysreq(UCHAR *);
int	cmd_sysset(UCHAR *);
int	sendComToPC(int);
int	sendSysToPC();

extern  ChAttr  *cd;		/* o͗p`lf[^̃|C^ */
extern  MnAttr  *md;		/* o͗pCf[^̃|C^ */

/* bkram.c */
extern unsigned int	prevblen, prevben, prevfreq;
extern UCHAR		pgmname[20];

int
cmd_ping(UCHAR *cb)
{
    putc(CMD_PINGOUT, stdout);
    return 1;
}

int
cmd_chdsend(UCHAR *cb)
{
    int		ch;
    unsigned char	sndbuf[24];

    ch = (int)cb[1];
    if (cb[0] == 'D') {
        sndbuf[0] = CMD_CHDSEND;	/* command No. */
        sndbuf[1] = (UCHAR)ch;		/* ch ԍ */
        sndbuf[2] = cd[ch].vol;		/* ch volume */
        sndbuf[3] = cd[ch].snd[0];	/* AUX1 Send */
        sndbuf[4] = cd[ch].snd[1];	/* AUX2 Send */
        sndbuf[5] = cd[ch].snd[2];	/* AUX3 Send */
        sndbuf[6] = cd[ch].snd[3];	/* AUX4 Send */
        sndbuf[7] = cd[ch].hi;		/* Tone High */
        sndbuf[8] = cd[ch].mid;		/* Tone Mid */
        sndbuf[9] = cd[ch].low;		/* Tone Low */
        sndbuf[10]= cd[ch].pan;		/* panpod */
        sndbuf[11]= cd[ch].mut;		/* mute */
        sndbuf[12]= cd[ch].sndsw;	/* AUX Send SW */
        putn(sndbuf, 13, stdout);
    } else if (cb[0] == 'N') {
        sndbuf[0] = CMD_NAMESEND;
        getChName(ch, &(sndbuf[1]));
        putn(sndbuf, 17, stdout);
    }
    return 1;
}

int
cmd_chdrcv(UCHAR *cb)
{
    int		ch;
    UCHAR	d, sndbuf[24];

    ch = (int)cb[0];
    disableIRQ();
    if (cd[ch].vol != cb[1]) {
        cd[ch].vol = cb[1];	    AFLAGON(cd[ch].vflg);
    }
    if (cd[ch].snd[0] != cb[2]) {
        cd[ch].snd[0] = cb[2];	    cd[ch].sflg |= 0x11;
    }
    if (cd[ch].snd[1] != cb[3]) {
        cd[ch].snd[1] = cb[3];	    cd[ch].sflg |= 0x22;
    }
    if (cd[ch].snd[2] != cb[4]) {
        cd[ch].snd[2] = cb[4];	    cd[ch].sflg |= 0x44;
    }
    if (cd[ch].snd[3] != cb[5]) {
        cd[ch].snd[3] = cb[5];	    cd[ch].sflg |= 0x88;
    }
    if (cd[ch].hi != cb[6]) {
        cd[ch].hi = cb[6];	    cd[ch].tflg |= 0x44;
    }
    if (cd[ch].mid != cb[7]) {
        cd[ch].mid = cb[7];	    cd[ch].tflg |= 0x22;
    }
    if (cd[ch].low != cb[8]) {
        cd[ch].low = cb[8];	    cd[ch].tflg |= 0x11;
    }
    if (cd[ch].pan != cb[9]) {
        cd[ch].pan = cb[9];	    cd[ch].tflg |= 0x88;
    }
    if (cd[ch].mut != cb[10]) {
        cd[ch].mut = cb[10];	    AFLAGON(cd[ch].vflg);
    }
    if ((cd[ch].sndsw & 0x01) && ((cb[11] & 0x01) == 0)) {
        cd[ch].sndsw &= 0xfe;	    cd[ch].sflg |= 0x11;
    } else if (((cd[ch].sndsw & 0x01) == 0) && (cb[11] & 0x01)) {
        cd[ch].sndsw |= 0x01;	    cd[ch].sflg |= 0x11;
    }
    if ((cd[ch].sndsw & 0x02) && ((cb[11] & 0x02) == 0)) {
        cd[ch].sndsw &= 0xfd;	    cd[ch].sflg |= 0x22;
    } else if (((cd[ch].sndsw & 0x02) == 0) && (cb[11] & 0x02)) {
        cd[ch].sndsw |= 0x02;	    cd[ch].sflg |= 0x22;
    }
    if ((cd[ch].sndsw & 0x04) && ((cb[11] & 0x04) == 0)) {
        cd[ch].sndsw &= ~0x04;	    cd[ch].sflg |= 0x44;
    } else if (((cd[ch].sndsw & 0x04) == 0) && (cb[11] & 0x04)) {
        cd[ch].sndsw |= 0x04;	    cd[ch].sflg |= 0x44;
    }
    if ((cd[ch].sndsw & 0x08) && ((cb[11] & 0x08) == 0)) {
        cd[ch].sndsw &= ~0x08;	    cd[ch].sflg |= 0x88;
    } else if (((cd[ch].sndsw & 0x08) == 0) && (cb[11] & 0x08)) {
        cd[ch].sndsw |= 0x08;	    cd[ch].sflg |= 0x88;
    }
    enableIRQ();
    /* Tone through is not supported */
    sndbuf[0] = 0x55;
    putn(sndbuf, 1, stdout);
    return 1;
}

int
cmd_chrcv(UCHAR *cb)
{
    unsigned int	ch, n;
    unsigned char	sw, fl;
    char		str[8];
    
    ch = (unsigned int)cb[1];
    switch(cb[0]) {
    case 'V':
        if (cd[ch].vol != cb[2]) {
            cd[ch].vol = cb[2];	AFLAGON(cd[ch].vflg);
        }
        if (cd[ch].mut != cb[3]) {
            cd[ch].mut = cb[3];	AFLAGON(cd[ch].vflg);
        }
        break;
    case 'A':
    case 'B':
    case 'C':
    case 'D':
        n  = (unsigned int)(cb[0] - 'A');
        if (cb[3] == 0) sw = 1;
        else            sw = 0;
        auxsendsw(ch, n, (unsigned int)cb[2], sw);
        break;
    case 'H':	tone(ch, EQHIGH, (unsigned int)cb[2]);    break;
    case 'M':	tone(ch, EQMID,  (unsigned int)cb[2]);    break;
    case 'L':	tone(ch, EQLOW,  (unsigned int)cb[2]);    break;
    case 'P':	tone(ch, PANPOD, (unsigned int)cb[2]);    break;
    }
    return 1;
}

int
cmd_mndsend(UCHAR *cb)
{
    int			axno;
    unsigned char	sndbuf[24];
    
    if (cb[0] == 'D') {
        sndbuf[ 0] = CMD_NAMESEND;
        sndbuf[ 1] = md->mainl;
        sndbuf[ 2] = md->mainr;
        sndbuf[ 3] = md->auxl[0];
        sndbuf[ 4] = md->auxr[0];
        sndbuf[ 5] = md->auxl[1];
        sndbuf[ 6] = md->auxr[1];
        sndbuf[ 7] = md->auxl[2];
        sndbuf[ 8] = md->auxr[2];
        sndbuf[ 9] = md->auxl[3];
        sndbuf[10] = md->auxr[3];
        sndbuf[11] = md->phonel;
        sndbuf[12] = md->phoner;
        sndbuf[13] = md->mnmut;
        putn(sndbuf, 14, stdout);
    } else if (cb[0] == 'N') {
        axno = (int)cb[1];
        sndbuf[0] = CMD_NAMESEND;
        getAuxName(axno, &(sndbuf[1]));
        putn(sndbuf, 17, stdout);
    }
    return 1;
}

int
cmd_mndrcv(UCHAR *cb)
{
    unsigned char	sndbuf[24];
    
    if((md->mainl)  != cb[0])  {md->mainl   = cb[0]; md->mnflg |= 0x11;}
    if((md->mainr)  != cb[1])  {md->mainr   = cb[1]; md->mnflg |= 0x22;}
    if((md->auxl[0])!= cb[2])  {md->auxl[0] = cb[2]; md->alflg |= 0x11;}
    if((md->auxr[0])!= cb[3])  {md->auxr[0] = cb[3]; md->arflg |= 0x11;}
    if((md->auxl[1])!= cb[4])  {md->auxl[1] = cb[4]; md->alflg |= 0x22;}
    if((md->auxr[1])!= cb[5])  {md->auxr[1] = cb[5]; md->arflg |= 0x22;}
    if((md->auxl[2])!= cb[6])  {md->auxl[2] = cb[6]; md->alflg |= 0x44;}
    if((md->auxr[2])!= cb[7])  {md->auxr[2] = cb[7]; md->arflg |= 0x44;}
    if((md->auxl[3])!= cb[8])  {md->auxl[3] = cb[8]; md->alflg |= 0x88;}
    if((md->auxr[3])!= cb[9])  {md->auxr[3] = cb[9]; md->arflg |= 0x88;}
    if((md->phonel) != cb[10]) {md->phonel = cb[10]; md->mnflg |= 0x44;}
    if((md->phoner) != cb[11]) {md->phoner = cb[11]; md->mnflg |= 0x88;}

    if ((md->mnmut & 0x01) != (cb[12] & 0x01)) {
        md->mnflg |= 0x11;
    }
    if ((md->mnmut & 0x02) != (cb[12] & 0x02)) {
        md->mnflg |= 0x22;
    }
    md->mnmut = cb[12];
    sndbuf[0] = CMD_ACK;
    putn(sndbuf, 1, stdout);
    return 1;
}

int
cmd_mnrcv(UCHAR *cb)
{
    if (cb[0] == 'V') {
        if((md->mainl) != cb[1]) {
            md->mainl   = cb[1]; md->mnflg |= 0x11;
        }
        if((md->mainr) != cb[2]) {
            md->mainr   = cb[2]; md->mnflg |= 0x22;
        }
        if ((md->mnmut & 0x01) != (cb[3] & 0x01)) {
            md->mnflg |= 0x11;
        }
        if ((md->mnmut & 0x02) != (cb[3] & 0x02)) {
            md->mnflg |= 0x22;
        }
        md->mnmut = cb[3];
    } else if (cb[0] == 'A') {
        if((md->auxl[0]) != cb[1]) {
            md->auxl[0] = cb[1]; md->alflg |= 0x11;
        }
        if((md->auxr[0]) != cb[2]) {
            md->auxr[0] = cb[2]; md->arflg |= 0x11;
        }
    } else if (cb[0] == 'B') {
        if((md->auxl[1]) != cb[1]) {
            md->auxl[1] = cb[1]; md->alflg |= 0x22;
        }
        if((md->auxr[1]) != cb[2]) {
            md->auxr[1] = cb[2]; md->arflg |= 0x22;
        }
    } else if (cb[0] == 'C') {
        if((md->auxl[2]) != cb[1]) {
            md->auxl[2] = cb[1]; md->alflg |= 0x44;
        }
        if((md->auxr[2]) != cb[2]) {
            md->auxr[2] = cb[2]; md->arflg |= 0x44;
        }
    } else if (cb[0] == 'D') {
        if((md->auxl[3]) != cb[1]) {
            md->auxl[3] = cb[1]; md->alflg |= 0x88;
        }
        if((md->auxr[3]) != cb[2]) {
            md->auxr[3] = cb[2]; md->arflg |= 0x88;
        }
    } else if (cb[0] == 'P') {
        if((md->phonel) != cb[1]) {
            md->phonel = cb[1]; md->mnflg |= 0x44;
        }
        if((md->phoner) != cb[2]) {
            md->phoner = cb[2]; md->mnflg |= 0x88;
        }
    }
    return 1;
}
    
int
cmd_pgm(UCHAR *cb)
{
    unsigned char	sndbuf[24];
    unsigned int	pno, def;
    int			flag, rtn;

    rtn = 1;
    if (cb[0] == 'Q') {
        sndbuf[0] = CMD_PGMNUM;
        pno = (UCHAR)getCurPgmNo();
        sndbuf[1] = (UCHAR)pno;
        if (queryDefPgm(pno))	sndbuf[2] = 1;
        else			sndbuf[2] = 0;
        putn(sndbuf, 3, stdout);
    } else if (cb[0] == 'L') {
        pno = (unsigned int)cb[1];
        if (loadPgm(pno, cd, md)) {
            pgmInfoToPC(pno);
        } else {
            pgmNGToPC();
        }
    } else if (cb[0] == 'S') {
        def  = (unsigned int)cb[1];
        savePgmFromPC(def, pgmname);
        putc(CMD_PGMEND, stdout);
        rtn = -2;
    } else if (cb[0] == 'I') {
        pno = (unsigned int)cb[1];
        pgmSetNo(pno);
    } else if (cb[0] == 'V') {
        pno = (unsigned int)cb[1];
        pgmInfoToPC(pno);
    }
    return(rtn);
}

int
cmd_pgmname(UCHAR *cb)
{
    unsigned char	sndbuf[4];
    int		i;

    if (cb[0] == 'P') {
        for (i=0; i<16; i++) {
            pgmname[i] = cb[i+2];
        }
        pgmname[17] = '\0';
    } else if (cb[0] == 'A') {
        setAuxName((int)cb[1], &(cb[2]));
    } else if (cb[0] == 'C') {
        setChName((int)cb[1], &(cb[2]));
    }
    sndbuf[0] = CMD_ACK;
    putn(sndbuf, 1, stdout);
    return 1;
}

int
cmd_pgmdate(UCHAR *cb)
{
    int		year;
    char	mon, day, hur, min, sec;
    char	buf[8];
    unsigned char	sndbuf[4];
    
    year = (UINT)cb[0] + 2000;
    mon  = cb[1];
    day  = cb[2];
    hur  = cb[4];
    min  = cb[5];
    sec  = cb[6];
    setPgmDate(year, mon, day, hur, min, sec);
    sndbuf[0] = CMD_ACK;
    putn(sndbuf, 1, stdout);
    return 1;
}

int
cmd_lock(UCHAR *cb)
{
    if (cb[0] == 0) {
	pcmnseton();
    } else {
        pcmnsetoff();
    }
    if (cb[1] == 0) {
	pcchseton();
    } else {
        pcchsetoff();
    }
    return 1;
}

void
pgmInfoToPC(int pgnum)
{
    char	buf[8];
    unsigned char sndbuf[24];
    
    sndbuf[0] = CMD_LOADOK;
    getCurPgmName(&(sndbuf[1]));
    getCurPgmDate(&(sndbuf[17]));
    putn(sndbuf, 23, stdout);
}

void
pgmNGToPC()
{
    int		i;
    unsigned char	sndbuf[24];
    
    for(i=0; i<23; i++) {
        sndbuf[i] = 0;
    }
    sndbuf[0] = CMD_LOADOK;
    sndbuf[1] = 0xff;
    putn(sndbuf, 23, stdout);
}

/************************************************************************
 *    VXeZbeBO֌W̑M                                  *
 ************************************************************************/
/**** VXẽNGXg ****/
int
cmd_sysreq(UCHAR *cb)
{
    unsigned int	ch;

    if (cb[0] == 'C') {
        ch = (unsigned int)cb[1];
        sendComToPC(ch);
    } else if (cb[0] == 'B') {
        sendSysToPC();
    }
    return 1;
}

/**** VXe̐ݒ ****/
int
cmd_sysset(UCHAR *cb)
{
    int		rtn, ch, data;

    rtn = 1;
    if (cb[0] == 'C') {
        ch   = (unsigned int)cb[1];
        data = (((unsigned int)cb[2]) <<8) | ((unsigned int)cb[3]);
        setSysParam(SCI_BPS, data, ch);		/* Baud rate */
        data = (unsigned int)cb[4];
        setSysParam(SCI_STOP, data, ch);	/* Stop bit */
        data = (unsigned int)cb[5];
        setSysParam(SCI_DLEN, data, ch);	/* Data length */
        data = (unsigned int)cb[6];
        setSysParam(SCI_PRTY, data, ch);	/* Parity bit */
        putc(CMD_ACK, stdout);
    } else if (cb[0] == 'B') {
        data = (((unsigned int)cb[1]) <<8) | ((unsigned int)cb[2]);
        setSysParam(BEEP_FREQ, data, 0);	/* Beep frequency */
        setBeepFreq(data);
        data = (((unsigned int)cb[3]) <<8) | ((unsigned int)cb[4]);
        setSysParam(BEEP_LEN, data, 0);		/* Beep length */
        setBeepLength(data);
        data = (unsigned int)cb[5];
        setSysParam(BEEP_ON, data, 0);		/* Beep enable */
        if (data == 0)    BeepDisable();
        else		  BeepEnable();
        data = (unsigned int)cb[6];
        setSysParam(STAMODE, data, 0);		/* start mode */
        data = (unsigned int)cb[7];
        setSysParam(CONTRAST, data, 0);		/* contrast */
        setContrast(data);
        putc(CMD_ACK, stdout);
    } else if (cb[0] == 'b') {
        prevblen = getBeepLen();
        prevben  = getBeepOn();
        prevfreq = getBeepFreq() * 100;
        data = (((unsigned int)cb[1]) <<8) | ((unsigned int)cb[2]);
        setBeepFreq(data);
        data = (((unsigned int)cb[3]) <<8) | ((unsigned int)cb[4]);
        setBeepLength(data);
        data = (unsigned int)cb[5];
        if (data == 0)    BeepDisable();
        else		  BeepEnable();
        Beep(0);
    } else if (cb[0] == 'c') {
        data = (unsigned int)cb[7];
        setContrast(data);
    } else if (cb[0] == 'D') {
        data = (unsigned int)cb[1];
        setSysParam(DEFPGM, data, 0);		/* Default program No. */
        putc(CMD_ACK, stdout);
    } else if (cb[0] == 'P') {
        sysParamRec();
        putc(CMD_PGMEND, stdout);
        rtn = -2;
    } else if (cb[0] == 'N') {
        setBeepFreq(prevfreq);
        setBeepLength(prevblen);
        if (prevben == 0)  BeepDisable();
        else               BeepEnable();
    }
    return rtn;
}

int
sendComToPC(int ch)
{
    int			bps;
    unsigned char	par,len, stp, data[12];
    
    bps = getSysBps(ch);
    par = getSysPrty(ch);
    len = getSysDlen(ch);
    stp = getSysStop(ch);

    data[0] = CMD_SYSENV;
    data[1] = 'C';
    data[2] = (unsigned char)ch;
    data[3] = (unsigned char)((bps & 0xff00) >> 8);
    data[4] = (unsigned char)(bps & 0xff);
    data[5] = stp;
    data[6] = len;
    data[7] = par;
    data[8] = 0x00;
    data[9] = 0x00;
    putn(data, 10, stdout);
    return 1;
}

int
sendSysToPC()
{
    unsigned int	freq, blen, bpen, dfno;
    unsigned char	ctrt, stam, data[12];
    
    freq = getSysBeepFreq();
    blen = getSysBeepLen();
    bpen = getSysBeepON();
    stam = getStartMode();
    ctrt = getSysContrast();
    dfno = getSysDefCh();

    data[0] = CMD_SYSENV;
    data[1] = 'B';
    data[2] = (unsigned char)((freq & 0xff00)>>8);
    data[3] = (unsigned char)(freq & 0x00ff);
    data[4] = (unsigned char)((blen & 0xff00)>>8);
    data[5] = (unsigned char)(blen & 0x00ff);
    data[6] = (unsigned char)bpen;
    data[7] = stam;
    data[8] = ctrt;
    data[9] = (unsigned char)dfno;
    putn(data, 10, stdout);
    return 1;
}

/* end of file */
