/************************************************************************
 *                                                                      *
 *    mem.c : @ANZX                                          *
 *                                                                      *
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"h8_3048.h"
#include	"sys.h"
#include	"ansi.h"
#include	"stdc.h"

#include	"shell.h"

int	mem(int, char **);
void	redmemByte(ULONG, int, int);
void	redmemShort(ULONG, int, int);
void	redmemInt(ULONG, int, int);
void	wrtmemByte(ULONG, ULONG, int);
void	wrtmemShort(ULONG, ULONG, int);
void	wrtmemInt(ULONG, ULONG, int);


static char ostyle = 'c';
static char *ctitle = "Address    : 00         +04         +08         +0c";
static char *stitle = "Address    : 00   02   04   06   08   0a   0c   0e";
static char *ititle = "Address    : 00       04       08       0c";

static char *helpmsg = "
m ..... read and write memory command.
Usage : mem [-d] [-c|-s|-i] address (data)
        -d : display decimal.
        -c : charactor size (byte).
        -s : short size (16bit).
        -i : int size (32bit).\n\r\n\r";

int
mem(int argc, char **argv)
{
    ULONG	a, b;
    int		i, omd, help, adrset, size;
    char	ostyle;
    char	str[8];

    help = 0;
    omd = 16;						/* 16io */
    adrset = 0;
    a = 0;
    b = 0;
    size = 0x100;
    ostyle = 'c';
    for(i=1; i<argc; i++) {
	if (strcmp(argv[i], "-d") == 0) {
	    omd = 10;					/* 10io */
	} else if (strcmp(argv[i], "-S") == 0) {
	    i++;
	    if (i >= argc) {
		help = 1;
		break;
	    }
	    size = (int)strtoi(argv[i]);
	} else if (strcmp(argv[i], "-c") == 0) {
	    ostyle = 'c';				/* 8bit P */
	} else if (strcmp(argv[i], "-s") == 0) {
	    ostyle = 's';				/* 16bit P */
	} else if (strcmp(argv[i], "-i") == 0) {
	    ostyle = 'i';				/* 32bit P */
	} else if (strcmp(argv[i], "-h") == 0) {
	    help = 1;
	} else {
	    if (adrset == 0) {
		a = (ULONG)strtoi(argv[i]);		/* addressݒ */
		adrset = 1;
	    } else if (adrset == 1) {
		b = (ULONG)strtoi(argv[i]);		/* dataݒ */
		adrset = 2;
	    }
	}
    }

    if (help) {
	puts(helpmsg, stdout);
	return(-1);
    }

    if (adrset == 0)	adrset = 1;
    switch(ostyle) {
    case 'c':
	if (adrset == 1)	redmemByte(a, omd, size);
	else if (adrset == 2)	wrtmemByte(a, b, omd);
	break;
    case 's':
	if (adrset == 1)	redmemShort(a, omd, size);
	else if (adrset == 2)	wrtmemShort(a, b, omd);
	break;
    case 'i':
	if (adrset == 1)	redmemInt(a, omd, size);
	else if (adrset == 2)	wrtmemInt(a, b, omd);
	break;
    }
    return(0);
}

void
redmemByte(ULONG a, int disp, int size)
{
    UCHAR	*adr, d;
    char	str[28];
    int		i;

    puts(ctitle, stdout);
    for(i=0; i<size; i++) {
	adr = (UCHAR *)(a + (ULONG)i);
	d = *adr;
	if ((i & 0x0f) == 0) {
	    puts("\n\r0x", stdout);
	    itonhstr(str, (ULONG)adr, 8);
	    puts(str, stdout);
	    puts(" : ", stdout);
	}
	itonhstr(str, d, 2);
	puts(str, stdout);
	putc(' ', stdout);
    }
    puts("\n\r", stdout);
}

void
redmemShort(ULONG a, int disp, int size)
{
    USHORT	*adr, d;
    char	str[28];
    int		i;
	
    puts(stitle, stdout);
    for(i=0; i<size; i=i+2) {
	adr = (USHORT *)(a + (ULONG)i);
	d = *adr;
	if ((i & 0x0f) == 0) {
	    puts("\n\r0x", stdout);
	    itonhstr(str, (ULONG)adr, 8);
	    strcat(str, " : ");
	    puts(str, stdout);
	}
	itonhstr(str, d, 4);
	puts(str, stdout);
	putc(' ', stdout);
    }
    puts("\n\r", stdout);
}

void
redmemInt(ULONG a, int disp, int size)
{
    ULONG	*adr, d;
    char	str[28];
    int		i;
	
    puts(ititle, stdout);
    for(i=0; i<size; i=i+4) {
	adr = (ULONG *)(a + (ULONG)i);
	d = *adr;
	if ((i & 0x0f) == 0) {
	    puts("\n\r0x", stdout);
	    itonhstr(str, (ULONG)adr, 8);
	    strcat(str, " : ");
	    puts(str, stdout);
	}
	itonhstr(str, d, 8);
	puts(str, stdout);
	putc(' ', stdout);
    }
    puts("\n\r", stdout);
}

void
wrtmemByte(ULONG a, ULONG b, int disp)
{
    UCHAR	*adr;
    char	str[28];

    adr = (UCHAR *)a;
    *adr = (UCHAR)b;

    puts("Byte : ", stdout);
    strcpy(str, "0x");
    itonhstr(&str[2], (ULONG)adr, 8);
    strcat(str, " = 0x");
    itonhstr(&str[15], b, 2);
    strcat(str, "\n\r");

    puts(str, stdout);
}

void
wrtmemShort(ULONG a, ULONG b, int disp)
{
    USHORT	*adr;
    char	str[32];

    if (a & 0x01) {
	strcpy(str, "Invalid address : 0x");
	itonhstr(&str[20], a, 8);
	strcat(str, "\n\r");
	puts(str, stdout);
	return;
    }
    adr  = (USHORT *)a;
    *adr = (USHORT)b;

    puts("Short : ", stdout);
    strcpy(str, "0x");
    itonhstr(&str[2], (ULONG)adr, 8);
    strcat(str, " = 0x");
    itonhstr(&str[15], b, 4);
    strcat(str, "\n\r");

    puts(str, stdout);
}
    
void
wrtmemInt(ULONG a, ULONG b, int disp)
{
    ULONG	*adr;
    char	str[32];

    if (a & 0x03) {
	strcpy(str, "Invalid address : 0x");
	itonhstr(&str[20], a, 8);
	strcat(str, "\n\r");
	puts(str, stdout);
	return;
    }

    adr = (ULONG *)a;
    *adr = b;

    puts("Int : ", stdout);
    strcpy(str, "0x");
    itonhstr(&str[2], (ULONG)adr, 8);
    strcat(str, " = 0x");
    itonhstr(&str[15], b, 8);
    strcat(str, "\n\r");

    puts(str, stdout);
}

/* end of file */

