/************************************************************************
 *                                                                      *
 *    misc.c : VFR}h                                           *
 *                                                                      *
 *    cntst ........ RgXg                                   *
 *                                                                      *
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"h8_3048.h"
#include	"sys.h"
#include	"ansi.h"
#include	"stdc.h"

#include	"shell.h"

int	cntst(int, char **);
int	setdbg(int, char **);

/************************************************************************
 *    LCDRgXg                                               *
 ************************************************************************/
static char *helpmsg = "
set LCD contrust.

cntst d

d is from 0 to 100 [%].\n\r";

int
cntst(int argc, char **argv)
{
    int		d;
    
    if (argc > 3) {
	puts(helpmsg, stdout);
	return(-1);
    }
    if (argc == 1) {
	puts(helpmsg, stdout);
	return(-1);
    }

    d = (int)strtoi(argv[1]);
    setContrast(d);
    
    return(1);
}

/************************************************************************
 *    fobOtOON/OFF                                              *
 ************************************************************************/
static char *dbghelp = "
toggle Debug flag.

dbg [n]
    n = 0 : volume set ON/OFF
    n = 1 : AUX Out Switch.\n";

int
setdbg(int argc, char **argv)
{
    int		d;
    
    if (argc > 3) {
	puts(dbghelp, stdout);
	return(-1);
    }
    if (argc == 1) {
	puts(helpmsg, stdout);
	return(-1);
    }

    d = (int)strtoi(argv[1]);
    /* toggleDebug(d); */
    
    return(1);
}

/************************************************************************
 *    printmap() :  memory map \                                     *
 ************************************************************************/
void
printmap(int argc, char **argv)
{
    puts("Memory map\n\r", stdout);
    puts(" __________________________________________ \n\r", stdout);
    puts(" |0x00000|         |                       |\n\r", stdout);
    puts(" |       |128KBytes| Internal Flash Memory |\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts(" |0x20000|         |                       |\n\r", stdout);
    puts(" |       |         |                       |\n\r", stdout);
    puts(" |       |512KBytes| External Flash Memory |\n\r", stdout);
    puts(" |       |         |                       |\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts(" |0xa0000|         |                       |\n\r", stdout);
    puts(" |       |256KBytes| External SRAM         |\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts(" |0xe0000|         |                       |\n\r", stdout);
    puts(" |       |         |  I/O                  |\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts(" |0xf0000|         |                       |\n\r", stdout);
    puts(" |       |         |  -                    |\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts(" |0xfef10|         |                       |\n\r", stdout);
    puts(" |       |  4KBytes| H8 Internal SRAM      |\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts(" |0xfff10|         |                       |\n\r", stdout);
    puts(" |       |         |  -                    |\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts(" |0xfff1c|         |                       |\n\r", stdout);
    puts(" |       |         |  Internal I/O Register|\n\r", stdout);
    puts(" |_______|_________|_______________________|\n\r", stdout);
    puts("\n\r", stdout);
}

/* end of file */

