/************************************************************************
 *                                                                      *
 *    setch : `l̐ݒ֐                                    *
 *                                                                      *
 *    setch ... Ώۃ`lݒ                                      *
 *    vol ..... {[ݒ                                          *
 *    high .... EQ-high ݒ                                            *
 *    mid ..... EQ-mid ݒ                                             *
 *    low ..... EQ-low ݒ                                             *
 *    pan ..... pan ݒ                                                *
 *    aux ..... auxout ݒ                                             *
 *                                                                      *
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"h8_3048.h"
#include	"sys.h"
#include	"ansi.h"
#include	"stdc.h"

#include	"shell.h"

int	setch(int, char **);
int	setvol(int, char **);
int	sethigh(int, char **);
int	setmid(int, char **);
int	setlow(int, char **);
int	setpan(int, char **);
int	setaux(int, char **);

/* static	int	curch=0; */
extern	int	curch;

int
checkVol(int vol)
{
    if (vol < 0)	return(-1);
    if (vol > 0x7f)	return(-1);
    return(0);
}

int
checkCh(int ch)
{
    if (ch < 0)		return(-1);
    if (ch > 0x0f)	return(-1);
    return(0);
}

int
checkAuxNum(int an)
{
    if (an < 0)		return(-1);
    if (an > 0x03)	return(-1);
    return(0);
}

/************************************************************************
 *    Ώۃ`l̐ݒ                                              *
 ************************************************************************/
static char *helpch = "
Usage : setch [ch]  ...... set target CH.\n\r";

int
setch(int argc, char **argv)
{
    char	str[32];
    
    if (argc > 3) {
	puts(helpch, stdout);
	return(-1);
    }

    if (argc == 1) {
	puts("CH is ", stdout);
	itostr(curch, str, 10);
	strcat(str, "\n\r");
	puts(str, stdout);
    } else {
	curch = (int)strtoi(argv[1]);
	puts("Set CH is ", stdout);
	puts(argv[1], stdout);
	puts("\n\r", stdout);
    }
    return(1);
}

static char *helpvol = "
Usage : vol [ch] [value] ...... set volume of target CH.\n\r";

int
setvol(int argc, char **argv)
{
    int		setv, ch;
    char	str[32];
    
    if (argc == 2) {
	setv = (int)strtoi(argv[1]);
        if (checkVol(setv)) {
            puts(helpvol, stdout);
            return(-1);
        }
	chvolume(curch, setv);
	strcpy(str, "CH");
	itostr(curch, &str[2], 10);
	strcat(str, " Volume = ");
	puts(str, stdout);
	puts(argv[1], stdout);
	puts("\n\r", stdout);
    } else if (argc == 3) {
        ch = (int)strtoi(argv[1]);
        if (checkCh(ch)) {
            puts(helpvol, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[2]);
        if (checkVol(setv)) {
            puts(helpvol, stdout);
            return(-1);
        }
	chvolume(ch, setv);
        puts("CH", stdout);
        puts(argv[1], stdout);
        puts(" Volume = ", stdout);
        puts(argv[2], stdout);
        puts("\n\r", stdout);
    } else {
        puts(helpvol, stdout);
        return(-1);
    }
    return(1);
    
}
    
static char *helph = "
Usage : high [ch] [value] ..... set EQ-high of target CH.\n\r";

int
sethigh(int argc, char **argv)
{
    int		setv, ch;
    char	str[32];

    if (argc == 2) {
        setv = (int)strtoi(argv[1]);
        if (checkVol(setv)) {
            puts(helph, stdout);
            return(-1);
        }
        tone(curch, EQHIGH, setv);
	strcpy(str, "CH");
	itostr(curch, &str[2], 10);
	strcat(str, " ToneHigh = ");
	puts(str, stdout);
	puts(argv[1], stdout);
	puts("\n\r", stdout);
    } else if (argc == 3) {
        ch = (int)strtoi(argv[1]);
        if (checkCh(ch)) {
            puts(helph, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[2]);
        if (checkVol(setv)) {
            puts(helph, stdout);
            return(-1);
        }
        tone(ch, EQHIGH, setv);
        puts("CH", stdout);
        puts(argv[1], stdout);
        puts(" ToneHgigh = ", stdout);
        puts(argv[2], stdout);
        puts("\n\r", stdout);
    } else {
        puts(helph, stdout);
        return(-1);
    }
    return(1);
}

static char *helpm = "
Usage : mid [ch] [value] ...... set EQ-mid of target CH.\n\r";

int
setmid(int argc, char **argv)
{
    int		setv, ch;
    char	str[32];

    if (argc == 2) {
        setv = (int)strtoi(argv[1]);
        if (checkVol(setv)) {
            puts(helpm, stdout);
            return(-1);
        }
        tone(curch, EQMID, setv);
	strcpy(str, "CH");
	itostr(curch, &str[2], 10);
	strcat(str, " ToneMid = ");
	puts(str, stdout);
	puts(argv[1], stdout);
	puts("\n\r", stdout);
    } else if (argc == 3) {
        ch = (int)strtoi(argv[1]);
        if (checkCh(ch)) {
            puts(helpm, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[2]);
        if (checkVol(setv)) {
            puts(helpm, stdout);
            return(-1);
        }
        tone(ch, EQMID, setv);
        puts("CH", stdout);
        puts(argv[1], stdout);
        puts(" ToneMid = ", stdout);
        puts(argv[2], stdout);
        puts("\n\r", stdout);
    } else {
        puts(helpm, stdout);
        return(-1);
    }
    return(1);
}

static char *helpl = "
Usage : low [ch] [value] ...... set EQ-low of target CH.\n\r";

int
setlow(int argc, char **argv)
{
    int		setv, ch;
    char	str[32];

    if (argc == 2) {
        setv = (int)strtoi(argv[1]);
        if (checkVol(setv)) {
            puts(helpl, stdout);
            return(-1);
        }
        tone(curch, EQLOW, setv);
	strcpy(str, "CH");
	itostr(curch, &str[2], 10);
	strcat(str, " ToneLow = ");
	puts(str, stdout);
	puts(argv[1], stdout);
	puts("\n\r", stdout);
    } else if (argc == 3) {
        ch = (int)strtoi(argv[1]);
        if (checkCh(ch)) {
            puts(helpl, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[2]);
        if (checkVol(setv)) {
            puts(helpl, stdout);
            return(-1);
        }
        tone(ch, EQLOW, setv);
        puts("CH", stdout);
        puts(argv[1], stdout);
        puts(" ToneLow = ", stdout);
        puts(argv[2], stdout);
        puts("\n\r", stdout);
    } else {
        puts(helpl, stdout);
        return(-1);
    }
    return(1);
}

static char *helpp = "
Usage : pan [value] ...... set PAN of target CH.\n\r";

int
setpan(int argc, char **argv)
{
    int		setv, ch;
    char	str[32];

    if (argc == 2) {
        setv = (int)strtoi(argv[1]);
        if (checkVol(setv)) {
            puts(helpp, stdout);
            return(-1);
        }
        tone(curch, PANPOD, setv);
	strcpy(str, "CH");
	itostr(curch, &str[2], 10);
	strcat(str, " Pan = ");
	puts(str, stdout);
	puts(argv[1], stdout);
	puts("\n\r", stdout);
    } else if (argc == 3) {
        ch = (int)strtoi(argv[1]);
        if (checkCh(ch)) {
            puts(helpp, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[2]);
        if (checkVol(setv)) {
            puts(helpp, stdout);
            return(-1);
        }
        tone(ch, PANPOD, setv);
        puts("CH", stdout);
        puts(argv[1], stdout);
        puts(" Pan = ", stdout);
        puts(argv[2], stdout);
        puts("\n\r", stdout);
    } else {
        puts(helpp, stdout);
        return(-1);
    }
    return(1);
}

static char *helpa = "
Usage : aux [ch] [n] [value] .. set AUX-[n] of target CH.\n\r";

int
setaux(int argc, char **argv)
{
    int		setv, ch, an;
    char	str[32];
    
    if (argc == 3) {
        an = (int)strtoi(argv[1]);
        if (checkAuxNum(an)) {
            puts(helpa, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[2]);
        if (checkVol(setv)) {
            puts(helpa, stdout);
            return(-1);
        }
        auxsend(curch, an, setv);
	strcpy(str, "CH");
	itostr(curch, &str[2], 10);
	strcat(str, " AUX");
	puts(str, stdout);
	puts(argv[1], stdout);
        puts(" = ", stdout);
        puts(argv[2], stdout);
	puts("\n\r", stdout);
    } else if (argc == 4) {
        ch = (int)strtoi(argv[1]);
        if (checkCh(ch)) {
            puts(helpa, stdout);
            return(-1);
        }
        an = (int)strtoi(argv[2]);
        if (checkAuxNum(an)) {
            puts(helpa, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[3]);
        if (checkVol(setv)) {
            puts(helpa, stdout);
            return(-1);
        }
        auxsend(ch, an, setv);
        puts("CH", stdout);    puts(argv[1], stdout);
        puts(" AUX", stdout);  puts(argv[2], stdout);
        puts(" = ", stdout);   puts(argv[3], stdout);
        puts("\n\r", stdout);
    } else {
        puts(helpa, stdout);
        return(-1);
    }
    return(1);
}

static char *helpas = "
Usage : auxsw [ch] [n] 0/1 .. set ch AUX-[n] on(1) or off(0).\n\r";

int
setauxsw(int argc, char **argv)
{
    int		setv, ch, an;
    char	str[32];
    
    if (argc == 3) {
        an = (int)strtoi(argv[1]);
        if (checkAuxNum(an)) {
            puts(helpas, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[2]);
        if (setv == 0) {
            auxsw(curch, an, OFF);
        } else if (setv == 1) {
            auxsw(curch, an, ON);
        } else {
            puts(helpas, stdout);
            return(-1);
        }
	strcpy(str, "CH");
	itostr(curch, &str[2], 10);
	strcat(str, " AUX");
	puts(str, stdout);
	puts(argv[1], stdout);
        puts(" = ", stdout);
        if (setv)	puts("ON\n\r", stdout);
        else		puts("OFF\n\r", stdout);
    } else if (argc == 4) {
        ch = (int)strtoi(argv[1]);
        if (checkCh(ch)) {
            puts(helpas, stdout);
            return(-1);
        }
        an = (int)strtoi(argv[2]);
        if (checkAuxNum(an)) {
            puts(helpas, stdout);
            return(-1);
        }
        setv = (int)strtoi(argv[3]);
        if (setv == 0) {
            auxsw(ch, an, OFF);
        } else if (setv == 1) {
            auxsw(ch, an, ON);
        } else {
            puts(helpas, stdout);
            return(-1);
        }
        puts("CH", stdout);    puts(argv[1], stdout);
        puts(" AUX", stdout);  puts(argv[2], stdout);
        puts(" = ", stdout);
        if (setv)	puts("ON\n\r", stdout);
        else		puts("OFF\n\r", stdout);
    } else {
        puts(helpas, stdout);
        return(-1);
    }
    return(1);
}

/* end of file */

