/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    update.c : \tgEFAAbvf[g֐                     ****
 ****                                                                ****
 ****----------------------------------------------------------------****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"h8_3048.h"
#include	"sys.h"
#include	"ansi.h"

/************************************************************************
 *    ֐錾                                                          *
 ************************************************************************/
/**** O֐ ****/
extern int     backspace();
extern int     cur_leftto(UCHAR *);
extern int     execCommand(char *);
extern ULONG   hstrtoi(char *);
extern UINT    itohstr(char *, ULONG, int);
extern ULONG   hstrtoni(char *, int);
extern UCHAR   read_byte(UCHAR *);

/**** ֐ ****/
BOOL	flashCheck();
BOOL	eraseALL();
BOOL	eraseSector(int);
void	updateApp();
void	write_flash(UCHAR *, UCHAR);

/************************************************************************
 *    flashCheck() : tbV R[h`FbN                    *
 ************************************************************************/
BOOL
flashCheck()
{
    UCHAR	*fptr;
    UCHAR	mcode, dcode;

    /* tbV [hZbg */
    fptr = (UCHAR *)EXT_FLASH_START;
    write_flash((UCHAR *)0x20555, 0xf0);

    /* VOl`[h */
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0xaa);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x20d4), 0x55);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0x90);
    fptr = (UCHAR *)EXT_FLASH_START;
    mcode = *fptr;				/* }jt@N`R[h */
    fptr = fptr + 1;
    dcode = *fptr;				/* foCXR[h */

    if (mcode != MBM29F040_MCODE)	return(FALSE);
    if (dcode != MBM29F040_DCODE)	return(FALSE);

    write_flash((UCHAR *)0x20555, 0xf0);	/* [hZbg */
    return(TRUE);
}

/************************************************************************
 *    erase () : @tbV֐                             *
 ************************************************************************/
char *erasehelpmsg =
"Usage: erase [num]\n\r        num = 0-7 : erase sector number.\n\r";

int
erase(int argc, char **argv)
{
    int		sn;
    
    if (argc != 2) {
        puts(erasehelpmsg, stdout);
        return(-1);
    }
    if (strcmp(argv[1], "-h") == 0) {
        puts(erasehelpmsg, stdout);
        return(-1);
    }

    sn = strtoi(argv[1]);
    eraseSector(sn);
}
        
/************************************************************************
 *    eraseAll() : tbV`bv                           *
 ************************************************************************/
BOOL
eraseAll(int argc, char **argv)
{
    UCHAR	*fptr;
    UCHAR	code;
    UINT	count[2], i;
    BOOL	er=TRUE;
    int		c;

    resetSci(stdio);
    puts("Erase All Flash memory!!\n\r", stdout);
    puts("Are you sure ? [y/n] ... ", stdout);
    while(1) {
        c = getc(stdin);
        if (c < 0)    continue;
        if ((c == 'y') || (c == '\n') || (c == '\r')) {
            puts("y\n\rOK... Erase All Flas memory\n\r", stdout);
            break;
        } else {
            puts("\n\rOK... cancel\n\r", stdout);
            return(FALSE);
        }
    }
        
    /* tbV [hZbg */
    write_flash((UCHAR *)EXT_FLASH_START, 0xf0);

    /* `bvC[YR}h */
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0xaa);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x20d4), 0x55);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0x80);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0xaa);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x20d4), 0x55);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0x10);

    for(i=0; i<1000; i++) { ; }			/* 50usecȏ҂ */
    fptr = (UCHAR *)EXT_FLASH_START;
    count[0] = 0;
    count[1] = 0;
    while(1) {
	code = *fptr;
	if (code == 0xff) {
	    fptr++;
	    code = *fptr;
	    if (code == 0xff)	break;
	    else		fptr--;
	}
	if(count[0] == 0xffff) {
	    count[1]++;
	    count[0] = 0;
	} else {
	    count[0]++;
	}
	if ((count[1] == 0x0262) && (count[0] == 0x5a00)) {
	    er = FALSE;				/* ő20b܂ő҂ */
	    break;
	}
    }
    
    /* tbV [hZbg */
    write_flash((UCHAR *)EXT_FLASH_START, 0xf0);
    resetSci(stdio);

    return(er);
}

/************************************************************************
 *    eraseSector() : tbV ZN^                       *
 ************************************************************************/
BOOL
eraseSector(int secnum)
{
    UCHAR	*fptr;
    UCHAR	code;
    UINT	count[2], i;
    BOOL	er=TRUE;

    if ((secnum < 0) || (secnum > 7)) return(FALSE);

    /* tbV [hZbg */
    write_flash((UCHAR *)EXT_FLASH_START, 0xf0);

    /* ZN^C[YR}h */
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0xaa);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x20d4), 0x55);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0x80);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x902b), 0xaa);
    write_flash((UCHAR *)(EXT_FLASH_START | 0x20d4), 0x55);
    write_flash((UCHAR *)(EXT_FLASH_START + (secnum * 0x10000)), 0x30);

    for(i=0; i<1000; i++) { ; }			/* 50usecȏ҂ */
    fptr = (UCHAR *)(EXT_FLASH_START | (secnum * 0x10000));
    count[0] = 0;
    count[1] = 0;
    while(1) {
	code = *fptr;
	if (code == 0xff) {
	    fptr++;
	    code = *fptr;
	    if (code == 0xff)	break;
	    else		fptr--;
	}
	if(count[0] == 0xffff) {
	    count[1]++;
	    count[0] = 0;
	} else {
	    count[0]++;
	}
	if ((count[1] == 0x0131) && (count[0] == 0x2d00)) {
	    er = FALSE;				/* ő10b܂ő҂ */
	    break;
	}
    }
    write_flash((UCHAR *)0x20555, 0xf0);	/* [hZbg */
    return(er);
}
    
/************************************************************************
 *    update() : Abvf[gR}h                                   *
 ************************************************************************/
char	*updatehelpmsg ="Usage : update [ram|0x...]
        ram   : program offset address is 0xa0000
        0x... : offset address\n\r";

int
update(int argc, char **argv)
{
    ULONG	baseaddr;
    
    if (argc == 1) {
        baseaddr = 0x20000;
    } else if (argc == 2) {
        if (strcmp(argv[1], "ram") == 0) {
            baseaddr = 0xa0000;
        } else if (strcmp(argv[1], "-h") == 0) {
            puts(updatehelpmsg, stdout);
            return(-1);
        } else {
            baseaddr = strtol(argv[1]);
        }
    }

    updateApp(baseaddr);
}

/************************************************************************
 *    updateApp() : AvP[V Abvf[g                       *
 ************************************************************************/
void
updateApp(ULONG badr)
{
    UCHAR	*adr, *linestart, *cur, *dest;
    char	linebuf[80], d, buf[10];
    int		l, n, finish, lsize, c, nlflag;
    long	psize, size, i;
    ULONG	base, tmp;

    for(i=0; i<0xffff; i++) { ; }
    getc(stdin);	getc(stdin);		/* _~[ǂ */
    puts("Please send program file (S-format) ...\n\r", stdout);

    /**** f[^M ****/
    finish = 0;
    adr = (UCHAR *)EXT_RAM_START;
    linestart = adr;
    size = 0;
    nlflag = 0;
    while(! finish) {
        while((c=getc(stdin)) <= 0) { ; }
	if(nlflag) {
	    if ((c == '\r') || (c == '\n'))  continue;
	}
	*adr = c;				/* M */
	if((*adr == '\n') || (*adr == '\r')) {
	    if((linestart[1] == 'S') && (linestart[2] == '7')){ finish = 1; }
	    if((linestart[1] == 'S') && (linestart[2] == '8')){ finish = 1; }
	    if((linestart[1] == 'S') && (linestart[2] == '9')){ finish = 1; }
	    linestart = adr;
	    nlflag = 1;
	}else{
	    nlflag = 0;
	}
	size++;
	adr++;
	if ((size%100) == 0)	putc('.', stdout);
    }

    /**** f[^WJ ****/
    puts("\n\r    Extracting...\n\r", stdout);
    cur = (UCHAR *)EXT_RAM_START;
    l = 0;
    base = (ULONG)0xa0000;		/* ) RAMX^[gAhX */
    for(i=0; i<size; i++) {
        if( (*cur == '\n') || (*cur == '\r') ){
            linebuf[l++] = '\0';                		/* sI[ */
	    if( (l != 0) && (hstrncmp(linebuf, "S2", 2) == 0) ){
		/* linbur[4]6Ă24bitAhX */
		adr = (UCHAR *)(hstrtoni(&linebuf[4], 6) - badr);
		if ((ULONG)adr < (ULONG)0x20000) {
		    adr = (UCHAR *)(base + (ULONG)adr);
		    lsize = (int)(hstrtoni(&linebuf[2], 2) - 1);
		    for(n=0; n<lsize; n++) {
			*adr = (UCHAR)hstrtoni(&linebuf[10+n*2], 2);
			adr++;
		    }
		}
	    }else if((l != 0) && (hstrncmp(linebuf, "S3", 2) == 0) ){
		adr = (UCHAR *)(hstrtoni(&linebuf[4], 8) - badr);
		if ((ULONG)adr < (ULONG)0x20000) {
		    adr = base + adr;
		    lsize = (int)(hstrtoni(&linebuf[2], 2) - 4 - 1);
		    for(n=0; n<lsize; n++) {
			*adr = (UCHAR)hstrtoni(&linebuf[12+n*2], 2);
			adr++;
		    }
		}
	    }
            l = 0;
        }else{
            linebuf[l++] = *cur;
        }
        cur++;
    }

    /**** tbV(ZN^0,1-128KByte) ****/
    puts("    Erasing...0,", stdout);
    eraseSector(0);				/* ZN^0  */
    puts("1", stdout);
    eraseSector(1);				/* ZN^1  */
    puts("\n\r", stdout);

    /**** f[^݁i128KBytej ****/
    puts("    Programming...\n\r", stdout);
    dest = (UCHAR *)0x20000;
    cur  = (UCHAR *)0xa0000;
    for(i=0; i<0x20000; i++) {
	write_flash((UCHAR *)0x2902b, 0xaa);
	write_flash((UCHAR *)0x220d4, 0x55);
	write_flash((UCHAR *)0x2902b, 0xa0);
	write_flash((UCHAR *)dest, *cur);
	for(c=0; c<10; c++) { ; }		/* \usec҂ */
	while(1) {
	    d = read_byte(dest);
	    if (d == *cur)	break;
	    if (d & 0x20)	continue;
	    if (d == *cur)	break;
	}
	cur++;
	dest++;
	adr = (UCHAR *)0x20000;	*adr = 0x0f;	/* [hZbg */
	if ((i%0x2000) == 0) {
            putc('.', stdout);
	}
    }
    puts("End update program.\n\r", stdout);
}

void
write_flash(UCHAR *adr, UCHAR data)
{
    int		i;

    *adr = data;
    for(i=0; i<10; i++) { ; }		/* 菑 */
}

/* end of file */
