/************************************************************************
 *                                                                      *
 *    h8sci.c : h8-3048 SCI                                         *
 *                                                                      *
 ************************************************************************/ 
#include	"include/generic.h"
#include	"include/h8_3048.h"

/************************************************************************
 *    錾                                                              *
 ************************************************************************/
/**** @OQƊ֐ ****/
extern	int	txbuf0Input(char);
extern	int	txbuf0Input2(char);
extern	int	txbuf0Inputs(char *, int);
extern	int	txbuf0Output(char *);
extern	int	rxbuf0Input(char);
extern	int	rxbuf0Output(char *);
extern	int	txbuf1Input(char);
extern	int	txbuf1Input2(char);
extern	int	txbuf1Inputs(char *, int);
extern	int	txbuf1Output(char *);
extern	int	rxbuf1Input(char);
extern	int	rxbuf1Output(char *);

/**** ֐錾 ****/
int	sci0ins(char *, int);
int	sci0in(void);
int	sci1ins(char *, int);
int	sci1in(void);
int	sci0out(char);
int	sci0outs(char *);
int	sci0outn(char *, int);
int	sci1out(char);
int	sci1outs(char *);
int	sci1outn(char *, int);

void	init_sci0();
void	init_sci1();

void	int_eri0();
void	int_rxi0();
void	int_txi0();
void	int_tei0();

void	int_eri1();
void	int_rxi1();
void	int_txi1();
void	int_tei1();

UCHAR	calcBrrValue(int);
int	sciSetBaud(int, int);
UINT	getSciBaud(int);
int	getSciDataLen(int);
int	getSciParity(int);
int	getSciStopBit(int);
int	sciSetMode(int, int, int, int);

/**** ϐ錾 ****/
extern int	tx0run, tx1run;
extern char	scistat0, scistat1;

/************************************************************************
 *    o͊֐                                                    *
 ************************************************************************/
/**** VACH0 LN^M(Mobt@̎o) ****/
int
sci0ins(char *s, int num)
{
    int		rtn;

    rtn = rxbuf0Outputs(s, num);
    return(rtn);
}

int
sci0in()
{
    int		i, rtn;
    char	c;
    
    rtn = rxbuf0Output(&c);		/* MLN^o */
    if(rtn)	i = (int)c & 0xff;	/* int ֕Ȃg */
    else	i = -1;			/* EOF */
    return(i);
}

/**** VACH1 LN^M(Mobt@̎o) ****/
int
sci1ins(char *s, int num)
{
    int		rtn;

    rtn = rxbuf1Outputs(s, num);
    return(rtn);
}
    
int
sci1in()
{
    int		i, rtn;
    char	c;
    
    rtn = rxbuf1Output(&c);		/* MLN^o */
    if(rtn)	i = (int)c & 0xff;	/* int ֕Ȃg */
    else	i = -1;			/* EOF */
    return(i);
}

/**** VACH0 LN^M(Mobt@ւ̏) ****/
int
sci0out(char c)
{
    int		rtn;

    rtn = 0;
    while(! rtn) {
        disableIRQ();			/* 荞݋֎~ */
        rtn = txbuf0Input2(c & 0xff);	/* LN^ */
        enableIRQ();			/* 荞݋ */
        if (tx0run == 0) {		/* MGveB̏ꍇ */
            tx0run = 1;
            SCR0 |= 0x80;		/* MGveB荞ON */
        }
    }
    return(rtn);
}

/**** VACH0 񑗐M(Mobt@ւ̏) ****/
int
sci0outs(char *s)
{
    int		n, len, d, r;
    
    n = strlen(s);			/*  */
    len = 0;
    d = 0;
    while(len < n) {
        len = len + d;
        r = n - len;
        disableIRQ();					/* 荞݋֎~ */
        d = txbuf0Inputs(&(s[len]), r);	/* 񏑂 */
        enableIRQ();			/* 荞݋ */
        if (tx0run == 0) {
            tx0run = 1;
            SCR0 |= 0x80;		/* MGveB荞ON */
        }
    }
    return(n);
}

/**** VAch0 w蕶M ****/
int
sci0outn(char *s, int num)
{
    int    len, d, r;

    d = 0;
    len = 0;
    while(len < num) {
        len = len + d;
        r = num - len;
        disableIRQ();
        d = txbuf0Inputs(&(s[len]), r);
        enableIRQ();
        if (tx0run == 0) {
            tx0run = 1;
            SCR0 |= 0x80;
        }
    }
    return(num);
}

/**** VACH1 LN^M(Mobt@ւ̏) ****/
int
sci1out(char c)
{
    int		rtn;

    rtn = 0;
    while(! rtn) {
        disableIRQ();			/* 荞݋֎~ */
        rtn = txbuf1Input2(c & 0xff);	/* LN^ */
        enableIRQ();			/* 荞݋ */
        if (tx1run == 0) {		/* MGveB̏ꍇ */
            tx1run = 1;
            SCR1 |= 0x80;		/* MGveB荞ON */
        }
    }
    return(rtn);
}

/**** VACH1 񑗐M(Mobt@ւ̏) ****/
int
sci1outs(char *s)
{
    int		n, len, d, r;

    n = strlen(s);			/*  */
    d = 0;
    len = 0;
    while(len < n) {
        len = len + d;
        r = n - len;
        disableIRQ();			/* 荞݋ */
        d = txbuf1Inputs(&(s[len]), r);			/* 񏑂 */
        enableIRQ();			/* 荞݋ */
        if (tx1run == 0) {
            tx1run = 1;
            SCR1 |= 0x80;		/* MGveB荞ON */
        }
    }
    return(n);
}

/**** VAch1 w蕶M ****/
int
sci1outn(char *s, int num)
{
    int    len, d, r;

    d = 0;
    len = 0;
    while(len < num) {
        len = len + d;
        r = num - len;
        if (r == 0) break;
        disableIRQ();
        d = txbuf1Inputs(&(s[len]), r);
        enableIRQ();
        if (tx1run == 0) {
            tx1run = 1;
            SCR1 |= 0x80;
        }
    }
    return(num);
}

/************************************************************************
 *    SCI                                                     *
 ************************************************************************/
void
init_sci0()
{
    int		i;

    tx0run = 0;
    scistat0 = 0;
    
    /****  ****/
    SCR0 = 0x00;
    SMR0 = 0x00;
    BRR0 = 0x0c;			/* 38400bps */

    for(i=0; i<0x100; i++) {;}		/* [hύX㎞Ԃ */

    /**** MJnEM荞݋ ****/
    SCR0 = TxON(INIT_SCR0) | RxON(INIT_SCR0);
    SCR0 |= 0x40;			/* Recieve Interrupt Enable */
    /* SCR0 |= 0x80; */			/* Transmit Interrupt Enable */
}

void
init_sci1()
{
    int		i;

    tx1run = 0;
    scistat1 = 0;

    /****  ****/
    SCR1 = 0x00;
    SMR1 = 0x00;
    BRR1 = 0x0c;			/* 38400bps */

    for(i=0; i<0x100; i++) {;}		/* [hύX㎞Ԃ */

    /**** MJn ****/
    SCR1 = TxON(INIT_SCR1) | RxON(INIT_SCR1);
    SCR1 |= 0x40;
    /* SCR1 |= 0x80; */
}

/************************************************************************
 *    SCI CH-0 荞ݏ                                             *
 ************************************************************************/
/**** MG[荞 ****/
void
sci_eri0()
{
    char	c;
    
    if( SSR0 & 0x20 ){			/* Over run Error */
    	SSR0 &= ~0x20;
        scistat0 = scistat0 | 0x20;
    }
    if( SSR0 & 0x10 ){			/* FER */
    	SSR0 &= ~0x10;
        c = RDR0;
        rxbuf1Input(c);
        SSR0 = SSR0 & 0xbf;
        scistat0 = scistat0 | 0x10;
    }	
    if( SSR0 & 0x08 ){			/* Parity Error */
    	SSR0 &= ~0x08;
        c = RDR0;
        rxbuf1Input(c);
        SSR0 = SSR0 & 0xbf;
        scistat0 = scistat0 | 0x08;
    }
}

/**** M荞 ****/
void
sci_rxi0()
{
    char	c;
    
    if (SSR0 & 0x40) {		/* V[uf[^`FbN */
	c = RDR0;
	rxbuf0Input(c);
	SSR0 = SSR0 & 0xbf;	/* Mf[^tONA */
    }
}

/**** Mf[^GveB荞 ****/
void
sci_txi0()
{
    char	c;
    int		n;
    
    if (SSR0 & 0x80) {		/* 荞ݗv`FbN */
	n = txbuf0Output(&c);
	if (n == 0) {
	    SCR0 &= 0x7f;	/* Mf[^GveB荞ݒ~ */
	    tx0run = 0;
	} else {
	    TDR0 = c;
	    SSR0 &= 0x7f;	/* Mf[^GveBNAMJn */
	    tx0run = 1;
	}
    }
}

/**** M荞 ****/
void
sci_tei0()
{
    ;				/* Ȃ(荞ݎgp) */
}

/************************************************************************
 *    SCI CH-1 荞ݏ                                             *
 ************************************************************************/
void
sci_eri1()
{
    char	c;
    
    if( SSR1 & 0x20 ){		/* Over Run Error clear */
    	SSR1 &= ~0x20;
        scistat1 = scistat1 | 0x20;
    }
    if( SSR1 & 0x10 ){		/* Framing Error clear */
    	SSR1 &= ~0x10;
        c = RDR1;
        rxbuf1Input(c);
        SSR1 = SSR1 & 0xbf;
        scistat1 = scistat1 | 0x10;
    }	
    if( SSR1 & 0x08 ){		/* parity Error clear */
    	SSR1 &= ~0x08;
        c = RDR1;
        rxbuf1Input(c);
        SSR1 = SSR1 & 0xbf;
        scistat1 = scistat1 | 0x08;
    }
}

/**** M荞 ****/
void
sci_rxi1()
{
    char	c;
    
    if (SSR1 & 0x40) {		/* V[uf[^`FbN */
	c = RDR1;
	rxbuf1Input(c);
	SSR1 = SSR1 & 0xbf;	/* Mf[^tONA */
    }
}

/**** Mf[^GveB荞 ****/
void
sci_txi1()
{
    char	c;
    int		n;

    if (SSR1 & 0x80) {		/* 荞ݗv`FbN */
	n = txbuf1Output(&c);
	if (n == 0) {
	    SCR1 &= 0x7f;	/* Mf[^GveB荞ݒ~ */
	    tx1run = 0;
	} else {
	    TDR1 = c;
	    SSR1 &= 0x7f;	/* Mf[^GveBNAMJn */
	    tx1run = 1;
	}
    }
}

/**** M肱 ****/
void
sci_tei1()
{
    ;				/* Ȃ(荞ݎgp) */
}

/************************************************************************
 *        H8 SCIp[eBeB֐                                    *
 ************************************************************************/
/**** {[[gvZ ****/
UCHAR
calcBrrValue(int b)
{
    UCHAR	value;
    
    switch(b) {
    case 960:    value = 51;    break;		/*   9600bps */
    case 1920:   value = 25;    break;		/*  19200bps */
    case 3125:   value = 15;    break;		/*  31250bps */
    case 3840:   value = 12;    break;		/*  38400bps */
    case 5760:   value = 8;     break;		/*  57600bps */
    case 6250:   value = 7;     break;		/*  62500bps */
    case 10000:  value = 4;     break;		/* 100000bps */
    case 12500:  value = 3;     break;		/* 125000bps */
    case 25000:  value = 1;     break;		/* 250000bps */
    default:     value = 12;    break;		/*  38400bps */
    }
    return(value);
}

/**** {[[gݒύX ****/
int
sciSetBaud(int ch, int baud)
{
    UCHAR	*regbrr, *regssr, *regscr, value, stat;
    int		i;

    if (ch = 0) {
        regbrr = (UCHAR *)BRR0Ptr;
        regssr = (UCHAR *)SSR0Ptr;
        regscr = (UCHAR *)SCR0Ptr;
    } else {
        regbrr = (UCHAR *)BRR1Ptr;
        regssr = (UCHAR *)SSR1Ptr;
        regscr = (UCHAR *)SCR1Ptr;
    }

    value = calcBrrValue(baud);
    while(1) {
        stat = asmReadByte(regssr);
        if (((stat & 0x84) == 0x84) && ((stat & 0x40) == 0)) break;
    }
    stat = asmReadByte(regscr);
    asmWriteByte((stat & 0xcf), regscr);	/* SCI ~ */
    asmWriteByte(value, regbrr);		/* BRR ݒ */
    for(i=0; i<0x1000; i++) {;}			/* [hύX㎞Ԃ */
    asmWriteByte(stat, regscr);			/* SCI ĊJ */
}

/**** ݒ肳ꂽ{[[g̎擾 ****/
UINT
getSciBaud(int ch)
{
    UCHAR		brrvalue;
    unsigned int	value;

    if (ch = 0)		brrvalue = BRR0;
    else		brrvalue = BRR1;

    switch(brrvalue) {
    case 51:	value = 960;    break;
    case 25:    value = 1920;   break;
    case 15:    value = 3125;   break;
    case 12:    value = 3840;   break;
    case 8:     value = 5760;   break;
    case 7:     value = 6250;   break;
    case 4:     value = 10000;  break;
    case 3:     value = 12500;  break;
    case 1:     value = 25000;  break;
    default:    value = 0;      break;
    }
    return(value);
}

/**** f[^OX̎擾 ****/
int
getSciDataLen(int ch)
{
    unsigned char	value;
    
    if (ch == 0)	value = SMR0;
    else		value = SMR1;

    if (value & 0x40)	return(7);
    else		return(8);
}

/**** peBԂ̎擾 ****/
int
getSciParity(int ch)
{
    unsigned char	value;
    
    if (ch == 0)	value = SMR0;
    else		value = SMR1;

    if ((value & 0x30) == 0x30)    	return(2);	/* parity Odd */
    else if ((value & 0x30) == 0x20)	return(1);	/* parity Even */
    else				return(0);	/* pairty None */
}

/**** stop bit Ԃ̎擾 ****/
int
getSciStopBit(int ch)
{
    unsigned char	value;
    if (ch == 0)	value = SMR0;
    else		value = SMR1;

    if (value & 0x08)	return(2);
    else		return(1);
}

/**** SCI modeݒ ****/
int
sciSetMode(int ch, int stop, int parity, int dlen)
{
    char	*regsmr, *regssr, *regscr, value, stat;
    int		i;

    if (ch = 0) {
        regsmr = (UCHAR *)SMR0Ptr;
        regssr = (UCHAR *)SSR0Ptr;
        regscr = (UCHAR *)SCR0Ptr;
    } else {
        regsmr = (UCHAR *)SMR1Ptr;
        regssr = (UCHAR *)SSR1Ptr;
        regscr = (UCHAR *)SCR1Ptr;
    }

    value = *regsmr;
    /**** Data Length ݒ ****/
    if (dlen == 8)	value &= 0xbf;		/* 8bit f[^OX */
    else if (dlen == 7)	value |= 0x40;		/* 7bit */

    /**** Parity ݒ ****/
    if (parity == 0) {				/* parity Ȃ */
	value &= 0xdf;
    } else if (parity == 1) {			/* parity Even */
        value |= 0x20;
        value &= 0xef;
    } else if (parity == 2) {			/* parity Odd */
        value |= 0x20;
        value |= 0x10;
    }

    /**** Stop bit ̐ݒ ****/
    if (stop == 1)	value &= 0xf7;		/* 1 stop bit */
    else if (stop == 2) value |= 0x08;		/* 2 stop bit */
        
    stat = asmReadByte(regscr);
    asmWriteByte((stat & 0xcf), regscr);	/* SCI ~ */
    asmWriteByte(value, regsmr);		/* BRR ݒ */
    for(i=0; i<0x1000; i++) {;}			/* [hύX㎞Ԃ */
    asmWriteByte(stat, regscr);			/* SCI ĊJ */
}

/* end of file */
