/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    led.c : LEDv                                           ****
 ****                                                                ****
 ****----------------------------------------------------------------****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"include/generic.h"
#include	"include/h8_3048.h"
#include	"include/config.h"

#define LEDLAMP		((UCHAR *)(0xe4002))
#define	LED7SEL		((UCHAR *)(0xe4003))
/**** VZOgLED _p^[ ****/
#define LEFTUPPER	(0x40)
#define LEFTLOWER	(0x80)
#define	LEFT7SEG	((UCHAR *)(0xe4004))

/**** VZOgLED̃p^[ݒ ****/
UCHAR leftLed[16] = {
    0x50, 0x77, 0x91, 0x15, 0x36, 0x1c, 0x18, 0x75,
    0x10, 0x14, 0x98, 0xbb, 0x1b, 0xef, 0x00, 0xff
};

UCHAR	leftptn[16] = {
    0x50, 0x77, 0x91, 0x15, 0x36, 0x1c, 0x18, 0x75,
    0x10, 0x14, 0x98, 0xbb, 0x1b, 0xef, 0x00, 0xff
};

/**** VZOgLED_p^[ ****/
#define CENTERUPPER	(0x10)
#define CENTERLOWER	(0x20)
#define	CENTER7SEG	((UCHAR *)(0xe4005))
/**** VZOgLED̃p^[ݒ ****/
UCHAR centLed[16] = {
    0x0a, 0xbb, 0x0d, 0x29, 0xb8, 0x68, 0x48, 0xab,
    0x08, 0x28, 0x4c, 0xdd, 0x59, 0xf7, 0x00, 0xff
};

UCHAR	cledptn[16] = {
    0x0a, 0xbb, 0x0d, 0x29, 0xb8, 0x68, 0x48, 0xab,
    0x08, 0x28, 0x4c, 0xdd, 0xfd, 0xf7, 0x00, 0xff
};

extern	UCHAR	subaMask;
extern	UCHAR	mainaMask;

extern UCHAR	ledMask, lampMask;
extern UCHAR	leftlow, leftup;
extern UCHAR	centerlow, centerup;
extern UCHAR	lonMask, loffMask;
extern UCHAR	conMask, coffMask;
extern UCHAR	lmonMask, lmoffMask;
extern int	ledsel, brinkcnt;

/************************************************************************
 *    LED                                                         *
 ************************************************************************/
void
ledInit()
{
    DASTCR = 0xFE;			/* DAX^oCRg[ */
    DACR   = 0xFF;			/* DARg[WX^ */

    DADR0 = 0x00;			/* DAf[^WX^ */
    DADR1 = 0x00;

    ledsel = 0;				/* LED _ItbO */
    ledMask = 0xf0;
    lampMask = 0x0f;

    lonMask = 0xff;
    loffMask = 0x00;
    conMask = 0xff;
    coffMask = 0x00;
    lmonMask = 0xff;
    lmoffMask = 0x00;
    brinkcnt = 0;
}

/************************************************************************
 *    Left LED o                                                     *
 ************************************************************************/
void
ledoutLeft(int num)
{
    int		high, low;
    
    if (num > 99)	return;
    high = num / 10;			/* 10ʂ̐(0-9) */
    low  = num % 10;			/* 1ʂ̐ (0-9) */

    leftlow = leftLed[low];
    if (high)	leftup = leftLed[high];
    else	leftup = 0xff;
}

int
ledoutLeftRaw(int up, int low)
{
    leftlow = leftptn[low];
    leftup  = leftptn[up];
}

/************************************************************************
 *    center LED o                                                   *
 ************************************************************************/
void
ledoutCenter(int num)
{
    int		high, low;

    if (num > 99)	return;
    high = num / 10;			/* 10ʂ̐(0-9) */
    low  = num % 10;			/* 1ʂ̐ (0-9) */

    centerlow = centLed[low];
    if (high)	centerup = centLed[high];
    else	centerup = 0xff;
}

int
ledoutCenterRaw(int up, int low)
{
    centerlow = cledptn[low];
    centerup  = cledptn[up];
}

/************************************************************************
 *    LED vo (4LEDv)                                   *
 ************************************************************************/
void
ledLampOut(UCHAR *sw)
{
    int		mask=0;

    if (sw[0])  mask |= 0x01;
    if (sw[1])  mask |= 0x02;
    if (sw[2])  mask |= 0x04;
    if (sw[3])  mask |= 0x08;
    
    lampMask = ~mask | mainaMask;
    asmWriteByte(LEDLAMP, ((lampMask&0x0f) | (mainaMask&0xf0)));
}

void
ledLampOut2(UCHAR sw)
{
    int		mask=0;
    
    if (sw & 0x01)    mask |= 0x01;
    if (sw & 0x02)    mask |= 0x02;
    if (sw & 0x04)    mask |= 0x04;
    if (sw & 0x08)    mask |= 0x08;

    lampMask = ~mask | mainaMask;
    asmWriteByte(LEDLAMP, ((lampMask&0x0f) | (mainaMask&0xf0)));
}
    
void
setLedMode(int mode, int target)
{
    switch(target) {
    case LED_LEFT:
	if(mode == BRINK) {
	    lonMask = 0xff;			/* and Ƃ */
	    loffMask = 0xff;			/* or Ƃ */
	} else if (mode == DOT_BRINK) {
	    lonMask = 0xef;			/* and Ƃ */
	    loffMask = 0x00;			/* or Ƃ */
	} else {
	    lonMask = 0xff;
	    loffMask = 0x00;
	}
        break;
    case LED_CENTER:
	if (mode == BRINK) {
	    conMask = 0xff;
	    coffMask = 0xff;
	} else if (mode == DOT_BRINK) {
	    conMask = 0xf7;
	    coffMask = 0x00;
	} else {
	    conMask = 0xff;
	    coffMask = 0x00;
	}
        break;
    case LED_LAMP:
	if (mode == BRINK) {
	    lmonMask = 0xff;
	    lmoffMask = 0xff;
	} else {
	    lmonMask = 0xff;
	    lmoffMask = 0x00;
	}
        break;
    }
}

/************************************************************************
 *    LED hCu֐ (8msec ɃR[)                               *
 ************************************************************************/
void
driveLed()
{
    UCHAR	left, center, mask;

    /**** \p^[ ****/
    if (ledsel) {
	ledsel = 0;
	ledMask = 0xa0 | subaMask;
	left  = leftup;
	center= centerup;
    } else {
	ledsel = 1;
	ledMask = 0x50 | subaMask;
	left   = leftlow;
	center = centerlow;
    }

    /**** _ŏ ****/
    brinkcnt++;
    if (brinkcnt > 62) {
	left = left & lonMask | loffMask;
	center = center & conMask | coffMask;
	if (brinkcnt > 125)	brinkcnt = 0;
    }

    /**** LED o ****/
    asmWriteByte(LED7SEL, ((ledMask&0xf0) | (subaMask&0x0f)));
    asmWriteByte(LEFT7SEG, left);
    asmWriteByte(CENTER7SEG, center);
}
    
/* end of file */
