/************************************************************************
 *                                                                      *
 *    init.c : H8 t@C                                        *
 *                                                                      *
 ************************************************************************/

#include	"generic.h"
#include	"config.h"
#include	"h8_3048.h"
#include	"sys.h"

/************************************************************************
 *    ֐錾                                                          *
 ************************************************************************/
void	init_sys(void);
void	startInt(void);
void	clearIrqStat(UCHAR);
void	inititu0(void);
int	waitmsec(int);
void	int_tick(void);
int	checkTimeFlag(UINT);
void	sysDummy(char *);
UCHAR	read_byte(UCHAR *);
int	clearSCIStat(int);
UCHAR	readSCIStat(int);
int	stopSCI(int);
int	stopSCIRx(int);
int	stopSCITx(int);
int	startSCIRx(int);
void	setBeepFreq(UINT);
UINT	getBeepFreq(void);
void	BeepOn(void);
void	BeepOff(void);

extern UINT	cnt2msec, timeflag;
extern UINT	beepFreq;
/************************************************************************
 *    VXe֐                                                *
 ************************************************************************/
void
init_sys()
{
    int    i;

    /**** VXeEoXRg[ ****/
    SYSCR = INIT_SYSCR;		/* VXeRg[ */
    ABWCR = INIT_ABWCR;		/* AhXoX */
    ASTCR = INIT_ASTCR;		/* ANZXXe[g */
    WCR   = INIT_WCR;		/* EFCgRg[ */
    WCER  = INIT_WCER;		/* EFCgECl[u */
    BRCR  = INIT_BRCR;		/* oX[XRg[ */
    CSCR  = INIT_CSCR;		/* `bvZNgݒ */

    /**** 荞݃Rg[ ****/
    ISCR = INIT_ISCR;		/* IRQ ZXRg[ */
    IPRA = INIT_IPRA;		/* 荞݃vCIeB A */
    IPRB = INIT_IPRB;		/* 荞݃vCIeB B */
    IER  = INIT_IER;		/* 荞݃Cl[u */

    /**** I/O|[gݒ ****/
    P1DDR = INIT_P1DDR;
    P2DDR = INIT_P2DDR;
    P4PCR = INIT_P4PCR;
    P5DDR = INIT_P5DDR;
    P5PCR = INIT_P5PCR;
    P8DDR = INIT_P8DDR;
    P9DDR = INIT_P9DDR;
    PADDR = INIT_PADDR;
    PBDDR = INIT_PBDDR;

    /**** VAR~jP[V ****/
    /*(|[O[hݒ) */
    SCR0 = INIT_SCR0;			/* 0x30 */
    SMR0 = INIT_SMR0;			/* 0x00 */
    BRR0 = INIT_BRR0;			/* 0x0c : 38400 bps */
    
    SCR1 = INIT_SCR1;			/* 0x30 */
    SMR1 = INIT_SMR1;			/* 0x00 */
    BRR1 = INIT_BRR1;			/* 0x0c : 38400 bps */

    for(i=0; i<0x2000; i++) {;}

    SCR0 = TxON(INIT_SCR0) | RxON(INIT_SCR0);
    SCR1 = TxON(INIT_SCR1) | RxON(INIT_SCR1);

    /**** X9241ւ̃f[^o͂1ɂĂ ****/
    *((UCHAR *)0xe500a) = 0xff;	/* ܂Ȃ */
}

void
startInt()
{
    SYSCR |= 0x08;			/* 荞݋ */
    asm("    andc    #127, ccr");	/* CCR:I ȊONA	*/
}

void
clearIrqStat(UCHAR mask)
{
    ISR = ISR & ~mask;
}

void
inititu0()
{
    cnt2msec = 0;
    timeflag = 0;

    /**** ITU ʐݒ ****/
    TSNC = INIT_TSNC;
    TMDR = INIT_TMDR;
    TFCR = INIT_TFCR;
    TOER = INIT_TOER;
    TOCR = INIT_TOCR;
    
    /**** ITU0 : ^Cx[XpJE^ ****/
    TCR0  = INIT_TCR0;
    TIOR0 = INIT_TIOR0;
    TIER0 = INIT_TIER0;
    GRA0  = INIT_GRA0;

    /**** ^C}X^[g ****/
    TSTR = 0x01;

}

int
waitmsec(int sec)
{
    UINT	msec = sec * 2000;
    UINT	i;

    for(i=0; i<msec; i++) {		/* 1 Loop 1msec */
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
	asm("    nop");    asm("    nop");
    }
}

/************************************************************************
 *    ITU0 : RyA}b`A 荞                                   *
 ************************************************************************/
void
int_tick()
{
    UCHAR	stat;
    UINT	d;

    stat = asmReadByte(0xfff67);

    cnt2msec++;
    timeflag = timeflag | T0002MSEC;
    d = cnt2msec & 0x1ff;
    if (d == 0x100)	{ timeflag = timeflag | T1024MSEC; }
    d = d & 0xff;
    if (d == 0x80)	{ timeflag = timeflag | T0512MSEC; }
    d = d & 0x7f;
    if (d == 0x40)	{ timeflag = timeflag | T0256MSEC; }
    d = d & 0x3f;
    if (d == 0x20)	{ timeflag = timeflag | T0128MSEC; }
    d = d & 0x1f;
    if (d == 0x10)	{ timeflag = timeflag | T0064MSEC; }
    d = d & 0x0f;
    if (d == 0x08)	{ timeflag = timeflag | T0032MSEC; }
    d = d & 0x07;
    if (d == 0x04)	{ timeflag = timeflag | T0016MSEC; }
    d = d & 0x03;
    if (d == 0x02)	{ timeflag = timeflag | T0008MSEC; }
    d = d & 0x01;
    if (d == 0x01)	{ timeflag = timeflag | T0004MSEC; }

    asmWriteByte(0xfff67, ~INT_GRAMASK);
}

int
checkTimeFlag(UINT mask)
{
    int		rtn;

    asm("    orc    #128, ccr");	/* 荞݋֎~	*/
    rtn = timeflag & mask;
    timeflag = timeflag & ~mask;
    asm("    andc    #127, ccr");	/* 荞݋	*/

    return(rtn);
}

/************************************************************************
 *    ݒ肳ĂȂ荞ݗp̃_~[֐                            *
 ************************************************************************/
void
sysDummy(char *string)
{
    if (string != NULL) {
        puts(string, stdout);
    }
    
    while(1) {;}
}
/************************************************************************
 *    read_byte() : 1Byte ̊mȃ[h(VXep)                    *
 ************************************************************************/
UCHAR
read_byte(UCHAR *ptr)
{
    UCHAR	d;

    d = *ptr;
    return(d);
}

/************************************************************************
 *    SCI p֐(|[O[hpj                                   *
 ************************************************************************/
int
clearSCIStat(int ch)
{
    UCHAR	s = SSR1;

    SSR1 = 0;
    return(s);
}

UCHAR
readSCIStat(int ch)
{
    if (ch == SCI_CH1)	return(SSR1);
    else		return(SSR0);
}

int
stopSCI(int ch)
{
    if (ch == SCI_CH1) {
	SCR1 = SCR1 & 0x03;
    } else {
	SCR0 = SCR0 & 0x03;
    }
}

int
stopSCIRx(int ch)
{
    if (ch == SCI_CH1) {
	SCR1 = SCR1 & 0xef;
    } else {
	SCR0 = SCR0 & 0xef;
    }
}

int
stopSCITx(int ch)
{
    if (ch == SCI_CH1) {
        SCR1 = SCR1 & 0xdf;
    } else {
        SCR0 = SCR0 & 0xdf;
    }
}

int
startSCIRx(int ch)
{
    if (ch == SCI_CH1) {
	SCR1 = SCR1 | 0x10;
    } else {
	SCR0 = SCR0 | 0x10;
    }
}

/************************************************************************
 *    Beepo͊֘A                                                    *
 ************************************************************************/
#define	ITUCLK	(20000)
void
setBeepFreq(UINT Hz)
{
    UINT	f;
    
    if ((Hz < 100) || (Hz > 20000)) {		/* 100Hz ` 20KHz ܂ */
        return;
    }
    beepFreq = Hz;
    f = Hz / 100;
    GRA4 = ITUCLK / f;
    TCNT4 = 0;
}

UINT	getBeepFreq()	{ return(beepFreq); }
void	BeepOn()	{ TSTR = 0x11; }
void	BeepOff() 	{ TSTR = 0x01; }


/* end of file */

