
typedef strcut {
    int		vol;
    int		hi;
    int		mid;
    int		low;
    int		pan;
    int		ax[4];
    int		axsw;
    int		mute;
} chAttr, *chAttrPtr;

typedef struct {
    int		main[2];
    int		phone[2];
    int		auxl[4];
    int		auxr[4];
    int		axlsw;
    int		axrsw;
    int		mmute;
    int		pmute;
} mainAttr, *mainAttrPtr;

typedef struct {
    int		update;
    int		ch;
    int		value[4]
    int		lr[4];
} lmAttr, *lmAttrPtr;

/* update group flag bit mask */
#define	CH01VOL		(0x0001)
#define	CH02VOL		(0x0004)
#define	CH03VOL		(0x0002)
#define	CH04VOL		(0x0008)
#define CH05VOL		(0x0001)
#define	CH06VOL		(0x0004)
#define	CH07VOL		(0x0002)
#define	CH08VOL		(0x0008)
#define	CH09VOL		(0x0001)
#define	CH10VOL		(0x0004)
#define	CH11VOL		(0x0002)
#define	CH12VOL		(0x0008)
#define	CH13VOL		(0x0001)
#define	CH14VOL		(0x0004)
#define	CH15VOL		(0x0002)
#define	CH16VOL		(0x0008)

#define	AUXR1L		(0x0010)
#define	AUXR2L		(0x0010)
#define	AUXR3L		(0x0010)
#define	AUXR4L		(0x0010)

#define	AUXR1R		(0x0020)
#define	AUXR2R		(0x0020)
#define	AUXR3R		(0x0020)
#define	AUXR4R		(0x0020)

#define	MAINLV		(0x1000)
#define	PHONLV		(0x1000)
#define	MAINRV		(0x2000)
#define	PHONRV		(0x2000)

#define	CH01AUX1	(0x0001)
#define	CH02AUX1	(0x0001)
#define	CH03AUX1	(0x0001)
#define	CH04AUX1	(0x0001)

#define	CH05AUX1	(0x0002)
#define	CH06AUX1	(0x0002)
#define	CH07AUX1	(0x0002)
#define	CH08AUX1	(0x0002)

#define	CH09AUX1	(0x0004)
#define	CH10AUX1	(0x0004)
#define	CH11AUX1	(0x0004)
#define	CH12AUX1	(0x0004)

#define	CH13AUX1	(0x0008)
#define	CH14AUX1	(0x0008)
#define	CH15AUX1	(0x0008)
#define	CH16AUX1	(0x0008)

#define	CH01AUX2	(0x0010)
#define	CH02AUX2	(0x0010)
#define	CH03AUX2	(0x0010)
#define	CH04AUX2	(0x0010)

#define	CH05AUX2	(0x0020)
#define	CH06AUX2	(0x0020)
#define	CH07AUX2	(0x0020)
#define	CH08AUX2	(0x0020)

#define	CH09AUX2	(0x0040)
#define	CH10AUX2	(0x0040)
#define	CH11AUX2	(0x0040)
#define	CH12AUX2	(0x0040)

#define	CH13AUX2	(0x0080)
#define	CH14AUX2	(0x0080)
#define	CH15AUX2	(0x0080)
#define	CH16AUX2	(0x0080)

#define	CH01AUX3	(0x0100)
#define	CH02AUX3	(0x0100)
#define	CH03AUX3	(0x0100)
#define	CH04AUX3	(0x0100)

#define	CH05AUX3	(0x0200)
#define	CH06AUX3	(0x0200)
#define	CH07AUX3	(0x0200)
#define	CH08AUX3	(0x0200)

#define	CH09AUX3	(0x0400)
#define	CH10AUX3	(0x0400)
#define	CH11AUX3	(0x0400)
#define	CH12AUX3	(0x0400)

#define	CH13AUX3	(0x0800)
#define	CH14AUX3	(0x0800)
#define	CH15AUX3	(0x0800)
#define	CH16AUX3	(0x0800)

#define	CH01AUX4	(0x1000)
#define	CH02AUX4	(0x1000)
#define	CH03AUX4	(0x1000)
#define	CH04AUX4	(0x1000)

#define	CH05AUX4	(0x2000)
#define	CH06AUX4	(0x2000)
#define	CH07AUX4	(0x2000)
#define	CH08AUX4	(0x2000)

#define	CH09AUX4	(0x4000)
#define	CH10AUX4	(0x4000)
#define	CH11AUX4	(0x4000)
#define	CH12AUX4	(0x4000)

#define	CH13AUX4	(0x8000)
#define	CH14AUX4	(0x8000)
#define	CH15AUX4	(0x8000)
#define	CH16AUX4	(0x8000)



int
setvol(int value, int ch)
{
    UCHAR	d;
    
    if (value > 0x7f)	return(-1);
    if (value < 0)	d = 0xff;
    else		d = 0x7f - (UCHAR)value;
    chd[ch].vol = d;
    lup = lup | lupmask[ch][VOLMASK];
    return(ch);
}

int
settone(int value, int ch, int range);
{
    UCHAR	d;
    int		rtn;

    if (value < -32)	return(-1);
    if (value >  31)	return(-1);
    d = 32 + (UCHAR)value;
    rtn = 1;
    switch(range) {
    case TONE_HIGH:
	chd[ch].hi = d;
	lup = lup | lupmask[ch][HIMASK];
	break;
    case TONE_MID:
	chd[ch].mid = d;
	lup = lup | lupmask[ch][MIDMASK];
	break;
    case TONE_LOW:
	chd[ch].low = d;
	lup = lup | lupmask[ch][LOWMASK];
	break;
    default:
	rtn = -1;
    }
    return(rtn);
}
    
int
setpan(int value, int ch)
{
    UCHAR	d;
    if (value < -32)	return(-1);
    if (value >  31)	return(-1);
    d = 32 + (UCHAR)value;
    chd[ch].pan = d;
    lup = lup | lupmask[ch][PANMASK];
    return(1);
}

int
setaux(int value, int ch, int no)
{
    UCHAR	d;

    if (value > 0x7f)	return(-1);
    if (no > 3)		return(-1);
    if (no < 0)		return(-1);
    if (value < 0)	d = 0xff;
    else		d = 0x7f - (UCHAR)value;
    chd[ch].aux[no] = d;
    switch(no) {
    case 0:	lup = lup | lupmask[ch][AUX1];	break;
    case 1:	lup = lup | lupmask[ch][AUX2];	break;
    case 2:	lup = lup | lupmask[ch][AUX3];	break;
    case 1:	lup = lup | lupmask[ch][AUX4];	break;
    }
    return(1);
}

int
setmain(int value, int lr)
{
    UCHAR	d;

    if (lr < 0)		return(-1);
    if (lr > 2)		return(-1);
    if (value > 0x7f)	return(-1);
    if (value < 0)	d = 0xff;
    else		d = 0x7f - (UCHAR)value;
    switch(lr) {
    case LCH:
	maind.main[LCH] = d;
	lup = lup | lupmask[MAIN][LCH];
	break;
    case RCH:
	maind.main[RCH] = d;
	lup = lup | lupmask[MAIN][RCH];
	break;
    case LRCH:
	maind.main[LCH] = d;
	maind.main[RCH] = d;
	lup = lup | lupmask[MAIN][LCH] | lupmask[MAIN][RCH];
	break;
    }
    return(1);
}
    
int
setphone(int value, int lr)
{
    UCHAR	d;

    if (lr < 0)		return(-1);
    if (lr > 2)		return(-1);
    if (value > 0x7f)	return(-1);
    if (value < 0)	d = 0xff;
    else		d = 0x7f - (UCHAR)value;
    switch(lr) {
    case LCH:
	maind.phone[LCH] = d;
	lup = lup | lupmask[PHONE][LCH];
	break;
    case RCH:
	maind.phone[RCH] = d;
	lup = lup | lupmask[PHONE][RCH];
	break;
    case LRCH:
	maind.phone[LCH] = d;
	maind.phone[RCH] = d;
	lup = lup | lupmask[PHONE][LCH] | lupmask[PHONE][RCH];
	break;
    }
    return(1);
}
    
int
setauxin(int value, int no, int lr)
{
    UCHAR	d;

    if (lr < 0)		return(-1);
    if (lr > 2)		return(-1);
    if (no < 0)		return(-1);
    if (no > 3)		return(-1);
    if (value > 0x7f)	return(-1);
    if (value < 0)	d = 0xff;
    else		d = 0x7f - (UCHAR)value;
    switch(lr) {
    case LCH:
	maind.auxl[no] = d;
	lup = lup | lupmask[AUXL][no];
	break;
    case RCH:
	maind.auxr[no] = d;
	lup = lup | lupmask[AUXR][no];
	break;
    case LRCH:
	maind.auxl[no] = d;
	maind.auxr[no] = d;
	lup = lup | lupmask[AUXL][no] | lupmask[AUXR][no];
	break;
    }
    return(1);
}
    


int	lturn, xturn;
ULONG	lup;
ULONG	xup[2];
ULONG	lumask[32] = {
    0x00000001, 0x00000002, 0x00000004, 0x00000008,
    0x00000010, 0x00000020, 0x00000040, 0x00000080,
    0x00000100, 0x00000200, 0x00000400, 0x00000800,
    0x00001000, 0x00002000, 0x00004000, 0x00008000,
    0x00010000, 0x00020000, 0x00040000, 0x00080000,
    0x00100000, 0x00200000, 0x00400000, 0x00800000,
    0x01000000, 0x02000000, 0x04000000, 0x08000000,
    0x10000000, 0x20000000, 0x40000000, 0x80000000
}

void
initSendData()
{
    lturn = 0;
    xturn = 0;
    lup = 0;
    xup[0] = 0;
    xup[1] = 0;
}

void
attriDataSend()
{
    int		i;

    if (lup) {
	for(i=0; i<24; i++) {
	    if (lup & upmask[lturn]) {
		lmset(lturn);
		send = 0x01;
		break;
	    }
	}
    }
}

void
attriDataSend()
{
    int		i;

    for(i=0; i<24; i++) {
	if (lup[i]) {
	    lmset(i);
	    send = 0x01;
	    break;
	}
    }
}

void
attriDataSend()
{
    int		i;
    char	send = 0;

    if (lup) {					/* XVsf */
	for (i=0; i<12; i++) {
	    if (lup & upmask[lturn]) {		/* XVtO`FbN */
		lup = lmset(lturn, lstat);	/* LM1972Mf[^Zbg */
		send = 0x01;
		break;
	    }
	    lturn++;				/* JE^CNg */
	    if (lturn >= 12)  lturn = 0;
	}
    }

    if (xup) {					/* XVsf */
	for (i=0; i<16; i++) {
	    if (xup & upmask[xturn]) {		/* tO`FbN */
		xup = xset(xturn, xstat);	/* XicorMf[^Zbg */
		send |= 0x02;
		break;
	    }
	}
	xturn++;				/* JE^CNg */
	if (xturn >= 64)  xturn = 0;
    }
    if (send)	*sendData = send;		/* f[^M */
}

int
lmout(int turn)
{
    *LMCH = lmdata[turn];
    *LMDA = lmdata[turn];
}

int
xcout(int turn)
{
    ;
}

