/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    pccom.c : PC ʐM                                       ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"include/generic.h"
#include	"include/config.h"
#include	"include/h8_3048.h"
#include	"include/sys.h"

/**** PC->Mixer R}h ****/
/* ch f[^MR}h */
#define	CMD_CHDREQ	(0x10)
#define CMD_CHDRCV	(0x11)
#define CMD_CHRCV	(0x12)

/* main f[^MR}h */
#define	CMD_MNDREQ	(0x20)
#define	CMD_MNDRCV	(0x21)
#define CMD_MNRCV	(0x22)

/* VXeݒ֘AMR}h */
#define	CMD_NONE	(0x00)
#define CMD_PGM		(0x30)
#define CMD_PGMNAME	(0x31)
#define CMD_PGMDATE	(0x32)
#define CMD_LOCK	(0x33)
#define CMD_SYSREQ	(0x40)
#define CMD_SYSSET	(0x41)
#define CMD_PINGIN	(0xaa)
#define CMD_PINGOUT	(0xa5)

/**** Mixer->PCR}h ****/
#define CMD_ACK		(0x55)
#define CMD_CHDSEND	(0x80)
#define CMD_PGMNUM	(0x82)
#define CMD_MNDSEND	(0x81)
#define CMD_NAMESEND	(0x83)
#define CMD_PGMEND	(0x88)
#define CMD_LOADOK	(0x89)
#define CMD_SYSENV	(0x8a)

extern	int	pgmInit(int);
extern	int	pgmIncDec(int);
extern	void	pcmnseton();
extern	void	pcchseton();

extern	int	cmd_chdsend(char *);
extern	int	cmd_chdrcv(char *);
extern	int	cmd_chrcv(char *);
extern	int	cmd_mndsend(char *);
extern	int	cmd_mndrcv(char *);
extern	int	cmd_mnrcv(char *);
extern	int	cmd_pgm(char *);
extern	int	cmd_pgmname(char *);
extern	int	cmd_pgmdate(char *);
extern	int	cmd_lock(char *);
extern	int	cmd_sysreq(char *);
extern	int	cmd_sysset(char *);
extern	int	cmd_ping(char *);

void	ctohexstr(char *, char *);
void	pcomInit(void);
int	pccom(int);

extern  ChAttr  *cd;		/* o͗p`lf[^̃|C^ */
extern  MnAttr  *md;		/* o͗pCf[^̃|C^ */
UCHAR	pcstat;
UCHAR	cbuf[20];
int	mcnt;
int	remain, curp;
int	(*f)();			/* M֐ւ̃|C^ */

/*
void
ctohexstr(char *dest, char *src)
{
    unsigned char	c;
    
    c = (src[0] & 0xf0) >> 4;
    if (c <=0x9)			dest[0] = c + '0';
    else if ((c >= 0xa) && (c <=0xf))   dest[0] = c - 0x0a + 'a';
    c = src[0] & 0x0f;
    if (c <=0x9)			dest[1] = c + '0';
    else if ((c >= 0xa) && (c <=0xf))   dest[1] = c - 0x0a + 'a';
    dest[2] = '\0';
}
*/

void
pcomInit()
{
    pcstat = CMD_NONE;			/* ʐM */
    remain = 0;				/* R}hcoCg */
    /*dsize = 0;*/			/* R}hTCY */
    f = NULL;
    mcnt = 0;				/* msecJE^ */
}

#define	OFF_TIME	4000
int
pccom(int msec)
{
    int		len, i, rtn, dsize;

    if (pcstat == CMD_NONE) {
        len = gets(cbuf, 1, stdin);		/* 1 */
        if (len == 0) {
            if (mcnt > OFF_TIME) {
                pcmnseton();
                pcchseton();
                pcomInit();
            } else {
                mcnt = mcnt + msec;
            }
            return(0);
        }
        switch(cbuf[0]) {
        case 0x10:  pcstat=CMD_CHDREQ;   dsize=2;  f=cmd_chdsend;  break;
        case 0x11:  pcstat=CMD_CHDRCV;   dsize=12; f=cmd_chdrcv;   break;
        case 0x12:  pcstat=CMD_CHRCV;    dsize=4;  f=cmd_chrcv;    break;
        case 0x20:  pcstat=CMD_MNDREQ;   dsize=2;  f=cmd_mndsend;  break;
        case 0x21:  pcstat=CMD_MNDRCV;   dsize=13; f=cmd_mndrcv;   break;
        case 0x22:  pcstat=CMD_MNRCV;    dsize=4;  f=cmd_mnrcv;    break;
        case 0x30:  pcstat=CMD_PGM;      dsize=2;  f=cmd_pgm;      break;
        case 0x31:  pcstat=CMD_PGMNAME;  dsize=18; f=cmd_pgmname;  break;
        case 0x32:  pcstat=CMD_PGMDATE;  dsize=7;  f=cmd_pgmdate;  break;
        case 0x33:  pcstat=CMD_LOCK;     dsize=2;  f=cmd_lock;     break;
        case 0x40:  pcstat=CMD_SYSREQ;   dsize=2;  f=cmd_sysreq;   break;
        case 0x41:  pcstat=CMD_SYSSET;   dsize=8;  f=cmd_sysset;   break;
        case 0xaa:  pcstat=CMD_PINGIN;   dsize=0;  f=cmd_ping;     break;
        default:    pcstat=CMD_NONE;     dsize=0;  f=NULL;         break;
        }
        remain = dsize;
        curp = 0;
    }
    if (remain) {
        len = gets(&(cbuf[curp]), remain, stdin);
        remain = remain - len;
        curp = curp + len;
        if (remain) {
            if (mcnt > OFF_TIME) {
                pcmnseton();
                pcchseton();
                pcomInit();
            } else {
                mcnt = mcnt + msec;
            }
            return(0);
        }
    }
    mcnt = 0;
    rtn = 1;
    if (f != NULL) {
        rtn = (*f)(cbuf);		/* M */
        f = NULL;
        pcstat = CMD_NONE;
        remain = 0;
        curp = 0;
    }
    return(rtn);
}

/*
 *
 *    CH7/AUX3: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x08
 *    CH8/AUX3: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x08
 *    CH3/AUX3: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x08
 *    CH4/AUX3: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x08
 *-----------------------------------------------------
 *    CH7/AUX4: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x08
 *    CH8/AUX4: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x08
 *    CH3/AUX4: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x08
 *    CH4/AUX4: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x08
 *-----------------------------------------------------
 *    CH5/AUX2: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x07
 *    CH6/AUX2: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x07
 *    CH1/AUX2: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x07
 *    CH2/AUX2: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x07
 *-----------------------------------------------------
 *    CH5/AUX1: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x07
 *    CH6/AUX1: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x07
 *    CH1/AUX1: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x07
 *    CH2/AUX1: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x07
 *-----------------------------------------------------
 *    CH7/AUX1: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x06
 *    CH8/AUX1: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x06
 *    CH3/AUX1: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x06
 *    CH4/AUX1: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x06
 *-----------------------------------------------------
 *    CH7/AUX2: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x06
 *    CH8/AUX2: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x06
 *    CH3/AUX2: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x06
 *    CH4/AUX2: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x06
 *-----------------------------------------------------
 *    CH5/AUX4: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x05
 *    CH6/AUX4: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x05
 *    CH1/AUX4: 0xe5014 --- 0x35015=0x01, 0xe500e=0x05
 *    CH2/AUX4: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x05
 *-----------------------------------------------------
 *    CH5/AUX3: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x05
 *    CH6/AUX3: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x05
 *    CH1/AUX3: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x05
 *    CH2/AUX3: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x05
 *-----------------------------------------------------
 *    CH13/AUX4: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x04
 *    CH14/AUX4: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x04
 *    CH09/AUX4: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x04
 *    CH10/AUX4: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x04
 *-----------------------------------------------------
 *    CH13/AUX3: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x04
 *    CH14/AUX3: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x04
 *    CH09/AUX3: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x04
 *    CH10/AUX3: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x04
 *-----------------------------------------------------
 *    CH13/AUX2: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x03
 *    CH14/AUX2: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x03
 *    CH09/AUX2: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x03
 *    CH10/AUX2: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x03
 *-----------------------------------------------------
 *    CH13/AUX1: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x03
 *    CH14/AUX1: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x03
 *    CH09/AUX1: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x03
 *    CH10/AUX1: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x03
 *-----------------------------------------------------
 *    CH15/AUX1: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x02
 *    CH16/AUX1: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x02
 *    CH11/AUX1: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x02
 *    CH12/AUX1: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x02
 *-----------------------------------------------------
 *    CH15/AUX2: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x02
 *    CH16/AUX2: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x02
 *    CH11/AUX2: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x02
 *    CH12/AUX2: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x02
 *-----------------------------------------------------
 *    CH15/AUX3: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x01
 *    CH16/AUX3: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x01
 *    CH11/AUX3: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x01
 *    CH12/AUX3: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x01
 *-----------------------------------------------------
 *    CH15/AUX4: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x01
 *    CH16/AUX4: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x01
 *    CH11/AUX4: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x01
 *    CH12/AUX4: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x01
 */
 
 
/*
 ** CH1(0) **
 *    CH1/AUX0: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x07
 *    CH1/AUX1: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x07
 *    CH1/AUX3: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x05
 *    CH1/AUX4: 0xe5014 --- 0x35015=0x01, 0xe500e=0x05
 ** CH2(1) **
 *    CH2/AUX0: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x07
 *    CH2/AUX1: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x07
 *    CH2/AUX3: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x05
 *    CH2/AUX4: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x05
 ** CH3(2) **
 *    CH3/AUX0: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x06
 *    CH3/AUX1: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x06
 *    CH3/AUX3: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x08
 *    CH3/AUX4: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x08
 ** CH4(3) **
 *    CH4/AUX0: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x06
 *    CH4/AUX1: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x06
 *    CH4/AUX3: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x08
 *    CH4/AUX4: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x08
 ** CH5(4) **
 *    CH5/AUX0: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x07
 *    CH5/AUX1: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x07
 *    CH5/AUX3: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x05
 *    CH5/AUX4: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x05
 ** CH6(5) **
 *    CH6/AUX0: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x07
 *    CH6/AUX1: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x07
 *    CH6/AUX3: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x05
 *    CH6/AUX4: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x05
 ** CH7(6) **
 *    CH7/AUX0: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x06
 *    CH7/AUX1: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x06
 *    CH7/AUX3: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x08
 *    CH7/AUX4: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x08
 ** CH8(7) **
 *    CH8/AUX0: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x06
 *    CH8/AUX1: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x06
 *    CH8/AUX3: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x08
 *    CH8/AUX4: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x08

 ** CH9(8) **
 *    CH9/AUX0: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x03
 *    CH9/AUX1: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x03
 *    CH9/AUX3: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x04
 *    CH9/AUX4: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x04
 ** CH10(9) **
 *    CH10/AUX0: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x03
 *    CH10/AUX1: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x03
 *    CH10/AUX3: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x04
 *    CH10/AUX4: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x04
 ** CH11(10) **
 *    CH11/AUX0: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x02
 *    CH11/AUX1: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x02
 *    CH11/AUX3: 0xe5014 --- 0xe5015=0x01, 0xe500e=0x01
 *    CH11/AUX4: 0xe5014 --- 0xe5015=0x00, 0xe500e=0x01
 ** CH12(11) **
 *    CH12/AUX0: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x02
 *    CH12/AUX1: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x02
 *    CH12/AUX3: 0xe5016 --- 0xe5017=0x01, 0xe500e=0x01
 *    CH12/AUX4: 0xe5016 --- 0xe5017=0x00, 0xe500e=0x01
 ** CH13(12) **
 *    CH13/AUX0: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x03
 *    CH13/AUX1: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x03
 *    CH13/AUX3: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x04
 *    CH13/AUX4: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x04
 ** CH14(13) **
 *    CH14/AUX0: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x03
 *    CH14/AUX1: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x03
 *    CH14/AUX3: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x04
 *    CH14/AUX4: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x04
 ** CH15(14) **
 *    CH15/AUX0: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x02
 *    CH15/AUX1: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x02
 *    CH15/AUX3: 0xe5010 --- 0xe5011=0x01, 0xe500e=0x01
 *    CH15/AUX4: 0xe5010 --- 0xe5011=0x00, 0xe500e=0x01
 ** CH16(15) **
 *    CH16/AUX0: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x02
 *    CH16/AUX1: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x02
 *    CH16/AUX3: 0xe5012 --- 0xe5013=0x01, 0xe500e=0x01
 *    CH16/AUX4: 0xe5012 --- 0xe5013=0x00, 0xe500e=0x01
 */

/* end of file */
