/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    comenv.c : COM|[gݒ                                    ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"include/sys.h"
#include	"h8_3048.h"

/**********************
 *[SCI Ch0]   57600bps*
 *  Len:8 Stp:1 Pty:Od*
 *[SCI Ch1]   57600bps*
 *  Len:8 Stp:1 Pty:D *
 **********************/
int	execComEnv();
int	comEnvLoop();

char	*pstr[3] = { "Pty:Ds", "Pty:Ev", "Pty:Od" };
extern	UCHAR	cdlen[2], cstop[2], cprty[2];
extern	UINT	cbps[2];

int
execComEnv()
{
    int		i;
    
    lcdCommand(CLEAR);
    lcdMoveto(0, 0);    lcdOut("[SCI Ch0]");
    lcdMoveto(2, 0);    lcdOut("[SCI Ch1]");
    for(i=0; i<2; i++) {
        cdlen[i] = getSysDlen(i);
        cstop[i] = getSysStop(i);
        cprty[i] = getSysPrty(i);
        cbps[i]  = getSysBps(i);
    }
    dispBaud();		lcdFlush();
    dispDataLen();	lcdFlush();
    dispStopLen();	lcdFlush();
    dispParity();	lcdFlush();
    lcdMoveto(0, 17);
    return(comEnvLoop());
}

int
comEnvLoop()
{
    UINT	bpcnt, bpmax, mode, rtn = 0;
    UCHAR	stat;
    
    checkTimeFlag(T0004MSEC);
    checkTimeFlag(T0008MSEC);
    checkTimeFlag(T0016MSEC);
    mode = 0;
    bpcnt = 0;
    while(1) {
	if (checkTimeFlag(T0004MSEC)) {
            pccom(4);
	}
	if (checkTimeFlag(T0008MSEC)) {
            bpmax = getBeepLen() >> 3;
            if (bpcnt < bpmax) { BeepOn();    bpcnt++; }
            else               { BeepOff(); }
	}
	/**** 16msec 62.5Hz ****/
	if (checkTimeFlag(T0016MSEC)) {
            stat  = (UCHAR)getSwStat(TACTSW, DOWN_STAT);
            if (stat & 0x01) {			/* Right(Next) */
                Beep();
                if (mode < 7)    mode++;
                dispCursor(mode);
            } else if (stat & 0x04) {		/* Left (Prev) */
                Beep();
                if (mode > 0)    mode--;
                dispCursor(mode);
            } else if (stat & 0x02) {		/* Up   (Inc) */
                Beep();
                incDecModeData(mode, 1);
            } else if (stat & 0x20) {		/* Down (Dec) */
                Beep();
                incDecModeData(mode, -1);
            } else if (stat & 0x10) {		/* Enter */
                Beep();
                saveComEnv();
                rtn = -2;
                break;
            } else if (stat & 0x40) {		/* Edit/Exit */
                Beep();
                rtn = -1;
                break;
            }
        }
    }
    return(rtn);
}
