/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    miscenv.c : X̊ݒ֐                              ****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
#include	"generic.h"
#include	"config.h"
#include	"include/sys.h"

extern	UCHAR	getStartMode();
extern	void	setStartMode(UCHAR);
extern	UCHAR	getBeepOn();

int	execSysEnv();

/*
 * Beep Setting
 * [    ]Hz [    ]msec
 * Display Contrast
 * |--------o--------|
 */
int
execSysEnv()
{
    int		mode, rtn = 0, d;
    UCHAR	bkcntrst, bkbeep, stat, bkstamd, contrast;
    UINT	bkfreq, bkmsec, bpcnt, bpmax;
    
    /*lcdCommand(CUR_ON);*/
    contrast = getContrast();
    bkcntrst = contrast / 4;
    bkbeep = getBeepOn();
    bkmsec = getBeepLen();
    bkstamd  = getStartMode();
    lcdCommand(BRINK_ON);
    lcdCommand(CLEAR);
    lcdCommand(CUR_HOME);
    lcdMoveto(0, 0);	lcdOut("Beep : ");
    lcdMoveto(1, 0);	lcdOut("[    ]Hz [    ]msec");
    lcdMoveto(2, 0);	lcdOut("Contrast [    ]");
    lcdMoveto(3, 0);    lcdOut("StartMode[    ]");
    dispBeepMsec();
    lcdFlush();
    for(mode=4; mode >= 0; mode--)  dispSysEnv(mode);
    mode = 0;
    bpcnt = 0;
    bpmax = getBeepLen() >> 3;
    while(1) {
	if (checkTimeFlag(T0004MSEC)) {
            pccom(4);
	}
	if (checkTimeFlag(T0008MSEC)) {
            bpmax = getBeepLen() >> 3;
            if (bpcnt < bpmax) { BeepOn();    bpcnt++; }
            else               { BeepOff(); }
	}
	/**** 16msec 62.5Hz ****/
	if (checkTimeFlag(T0016MSEC)) {
            stat  = (UCHAR)getSwStat(TACTSW, DOWN_STAT);
            if (stat & 0x01) {			/* Right (No) */
                if (mode < 4)    mode++;
                dispSysEnv(mode);
            } else if (stat & 0x04) {		/* Left (Yes) */
                if (mode > 0)    mode--;
                dispSysEnv(mode);
            } else if (stat & 0x02) {		/* Up */
                if (editSysEnv(mode, 1))  bpcnt = 0;
            } else if (stat & 0x20) {		/* Down */
                if (editSysEnv(mode, -1)) bpcnt = 0;
            } else if (stat & 0x10) {		/* Enter */
                saveSysEnv();
                rtn = -2;
                Beep();
                break;
            } else if (stat & 0x40) {		/* Edit/Exit */
                if (bkbeep)    BeepEnable();
                else           BeepDisable();
                setBeepFreq(bkfreq);
                setSysParam(BEEP_FREQ, bkfreq);
                setBeepLength(bkmsec);
                setSysParam(BEEP_LEN, bkmsec);
                setContrast(bkcntrst * 4);
                setSysParam(CONTRAST, bkcntrst*4);
                setStartMode(bkstamd);
                rtn = -1;
                Beep();
                break;
            }
        }
    }
    return(rtn);
}

/* end of file */
