/************************************************************************
 *
 *    sys.c :
 *
 ************************************************************************/ 
#include	"include/generic.h"
#include	"include/config.h"
#include	"include/h8_3048.h"

void	sysinit();
int	checkTimeFlag(UINT);
void	int_irq0();
void	int_irq1();
void	sysDummy(char *);
int	halt();

extern	UINT	cnt2msec, timeflag;
extern	UCHAR	runinit;
extern	int	curch;
extern  SysAttr sysParam;
/*UINT	beepFreq;*/
UCHAR	uracnt;

/************************************************************************
 *    sysinit() : VXeCjVCY                                *
 ************************************************************************/
void
sysinit()
{
    /**** VAIF ̒~ ****/
    SYSCR &= 0xf7;
    SCR0 = 0x00;    
    SMR0 = 0x00;
    TDR0 = 0xff;
    SCR0 = 0x00;

    SCR1 = 0x00;
    SMR1 = 0x00;
    TDR1 = 0xff;
    SCR1 = 0x00;

    SYSCR |= 0x08;			/* 荞݋ */
    asm("    andc    #127, ccr");	/* CCR:I NA */
    
    cnt2msec = 0;
    timeflag = 0;
    uracnt = 0;
    /* IPRA = INIT_IPRA; */
    ASTCR = INIT_ASTCR;			/* ANZXXe[gRg[ */
    WCR   = INIT_WCR;			/* EFCgRg[WX^ */
    /* WCER  = INIT_WCER; */		/* EFCgCl[uWX^ */
    
    /**** ITU ʐݒ ****/
    TSNC = INIT_TSNC;
    TMDR = INIT_TMDR;
    TFCR = INIT_TFCR;
    TOER = INIT_TOER;
    TOCR = INIT_TOCR;
    
    /**** ITU0 : ^Cx[XpJE^ ****/
    TCR0  = INIT_TCR0;	/* 0xa3 */	/* GRA/GRB AEgvbgRyA */
    TIOR0 = INIT_TIOR0;	/* 0x88 */	/* o͂Ȃ */
    TIER0 = INIT_TIER0;	/* 0xfb */	/* GRA/GRB RyA荞ݔ */
    GRA0  = INIT_GRA0;	/* 4000 */
    GRB0  = INIT_GRB0;	/* 2000 */

    /**** ITU4 : Beep pJE^ ****/
    TCR4  = INIT_TCR4;
    TIOR4 = INIT_TIOR4;
    TIER4 = INIT_TIER4;
    GRA4  = 1000;			/* 1000 : 2KHz */
    GRB4  = INIT_GRB4;

    /**** ^C}X^[g(ITU0:ON/ITU4OFF) ****/
    TSTR = 0x01;

    /**** X9241ւ̃f[^o͂1ɂĂ ****/
    *((UCHAR *)0xe500a) = 0xff;	/* ܂Ȃ */
}

/************************************************************************
 *    ITU0 GRB RyA荞                                         *
 ************************************************************************/
void
int_imib0() {
    UCHAR	stat, d;

    stat = asmReadByte(0xfff67);
    if (runinit) {			/*  */
        asmWriteByte(0xfff67, (stat &~INT_GRBMASK));
        return;
    }
    adinput(curch);			/* AD */
    volSet();				/* Volume ݒ(o) */
    outToLcd();				/* LCD 쓮 */
    uracnt++;				/* JE^CNg */
    d = uracnt & 0x07;
    if (d == 0x04) { swinput(); }	/* XCb`͏ */
    d = d & 0x03;
    if (d == 0x02) { driveLed(); }	/* LED 쓮 */
    asmWriteByte(0xfff67, (stat &~INT_GRBMASK));
}

/************************************************************************
 *    O荞0
 ************************************************************************/
void
int_irq0()
{
    clearIrqStat(NUM_IRQ0);	/* Status Clear(̊荞ݑҋ@) */
}

/************************************************************************
 *    O荞1
 ************************************************************************/
void
int_irq1()
{
    clearIrqStat(NUM_IRQ1);	/* Status Clear(̊荞ݑҋ@j */
}

/************************************************************************
 *    ݒ肳ĂȂ荞ݗp̃_~[֐                            *
 ************************************************************************/
void
sysDummy(char *string)
{
    while(1) {;}
}
/************************************************************************
 *   `ς݊֐iHALT,荞݃xN^j  
 ************************************************************************/

/*---- HALT ----*/
int halt(){ while(1) { ; } }

/*---- IRQ ----*/
void	int_nmi() { sysDummy("NMI"); }
void	int_trap0() { sysDummy("TRAP0"); }
void	int_trap1() { sysDummy("TRAP1"); }
void	int_trap2() { sysDummy("TRAP2"); }
void	int_trap3() { sysDummy("TRAP3"); }
//void	int_irq0() { sysDummy("IRQ0"); }	/*---- sys USB ----*/
//void	int_irq1() { sysDummy("IRQ1"); }	/*---- sys CAN ----*/
void	int_irq2() { sysDummy("IRQ2"); }
void	int_irq3() { sysDummy("IRQ3"); }
void	int_irq4() { sysDummy("IRQ4"); }
void	int_irq5() { sysDummy("IRQ5"); }
void	int_wovi() { sysDummy("WOVI"); }
void	int_cmi() { sysDummy("CMI"); }

/*---- ITU ----*/
void	int_ovi0() { sysDummy("OVI0"); }
void	int_imia1() { sysDummy("IMIA1"); }
void	int_imib1() { sysDummy("IMIB1"); }
void	int_ovi1() { sysDummy("OVI1"); }
void	int_imia2() { sysDummy("IMIA2"); }
void	int_imib2() { sysDummy("IMIB2"); }
void	int_ovi2() { sysDummy("OVI2"); }
void	int_imia3() { sysDummy("IMIA3"); }
void	int_imib3() { sysDummy("IMIB3"); }
void	int_ovi3() { sysDummy("OVI3"); }
void	int_imia4() { sysDummy("IMIA4"); }
void	int_imib4() { sysDummy("IMIB4"); }
void	int_ovi4() { sysDummy("OVI4"); }

/*---- DMA ----*/
void	int_dend0a() { sysDummy("DEND0A"); }
void	int_dend0b() { sysDummy("DEND0B"); }
void	int_dend1a() { sysDummy("DEND1A"); }
void	int_dend1b() { sysDummy("DEND1B"); }
/*---- ITU ----*/

/**** SCI֘A h8sci.cɋLq ****/
/* void	int_eri0() { LIBint_eri0(); } */
/* void	int_rxi0() { LIBint_rxi0(); } */
/* void	int_txi0() { LIBint_txi0(); } */
/* void	int_tei0() { LIBint_tei0(); } */
/* void	int_eri1() { LIBint_eri1(); } */
/* void	int_rxi1() { LIBint_rxi1(); } */
/* void	int_txi1() { LIBint_txi1(); } */
/* void	int_tei1() { LIBint_tei1(); } */
/*---- AD ----*/
void	int_adi() { sysDummy("ADI"); }


/* end of file */
